(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('classnames'), require('react-style-system'), require('uid'), require('react-dom')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react', 'classnames', 'react-style-system', 'uid', 'react-dom'], factory) :
  (global = global || self, factory(global.HackerUI = {}, global.React, global.classNames, global.reactStyleSystem, global.uid, global.ReactDOM));
}(this, (function (exports, React, classNames, reactStyleSystem, uid, reactDom) { 'use strict';

  var React__default = 'default' in React ? React['default'] : React;
  classNames = classNames && Object.prototype.hasOwnProperty.call(classNames, 'default') ? classNames['default'] : classNames;
  uid = uid && Object.prototype.hasOwnProperty.call(uid, 'default') ? uid['default'] : uid;

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  function _taggedTemplateLiteral(strings, raw) {
    if (!raw) {
      raw = strings.slice(0);
    }

    return Object.freeze(Object.defineProperties(strings, {
      raw: {
        value: Object.freeze(raw)
      }
    }));
  }

  function _templateObject12() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject12 = function _templateObject12() {
      return data;
    };

    return data;
  }

  function _templateObject11() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject11 = function _templateObject11() {
      return data;
    };

    return data;
  }

  function _templateObject10() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject10 = function _templateObject10() {
      return data;
    };

    return data;
  }

  function _templateObject9() {
    const data = _taggedTemplateLiteral(["\n      padding: ", " ", ";\n      min-width: ", ";\n      font-size: 0.8rem;\n    "]);

    _templateObject9 = function _templateObject9() {
      return data;
    };

    return data;
  }

  function _templateObject8() {
    const data = _taggedTemplateLiteral(["\n      padding: ", " ", ";\n      min-width: ", ";\n    "]);

    _templateObject8 = function _templateObject8() {
      return data;
    };

    return data;
  }

  function _templateObject7() {
    const data = _taggedTemplateLiteral(["\n      padding: ", " ", ";\n      min-width: ", ";\n    "]);

    _templateObject7 = function _templateObject7() {
      return data;
    };

    return data;
  }

  function _templateObject6() {
    const data = _taggedTemplateLiteral(["\n      color: ", ";\n      border: 2px solid transparent;\n      transition: background-color ", ",\n        border ", ";\n\n      &:focus {\n        background-color: ", ";\n        /* TODO: there's a bug in react-style-system that requires prettier-ignore */\n        /* prettier-ignore */\n        border: 2px solid ", ";\n      }\n      &:hover {\n        background-color: ", ";\n      }\n      &:active {\n        background-color: ", ";\n      }\n      &:disabled {\n        color: ", ";\n        background-color: transparent;\n      }\n    "]);

    _templateObject6 = function _templateObject6() {
      return data;
    };

    return data;
  }

  function _templateObject5() {
    const data = _taggedTemplateLiteral(["\n      background-color: ", ";\n      color: ", " !important;\n      border: 2px solid transparent;\n      transition: background-color ", ",\n        border ", ";\n\n      &:focus {\n        background-color: ", ";\n        border: 2px solid ", ";\n      }\n      &:hover {\n        background-color: ", ";\n      }\n      &:active {\n        background-color: ", ";\n        border: 2px solid ", ";\n      }\n      &:disabled {\n        background-color: ", ";\n        border: 2px solid transparent;\n        color: ", ";\n      }\n    "]);

    _templateObject5 = function _templateObject5() {
      return data;
    };

    return data;
  }

  function _templateObject4() {
    const data = _taggedTemplateLiteral(["\n      border: 1px solid ", ";\n      color: ", ";\n\n      transition: background-color ", ",\n        border ", ";\n\n      &:focus {\n        background-color: ", ";\n      }\n      &:hover {\n        background-color: ", ";\n      }\n      &:active {\n        background-color: ", ";\n      }\n      &:disabled {\n        color: ", ";\n        background-color: transparent;\n      }\n    "]);

    _templateObject4 = function _templateObject4() {
      return data;
    };

    return data;
  }

  function _templateObject3() {
    const data = _taggedTemplateLiteral(["\n      border-radius: 99999px;\n      & > svg {\n        width: ", ";\n        height: ", ";\n      }\n    "]);

    _templateObject3 = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2() {
    const data = _taggedTemplateLiteral(["\n      min-width: ", ";\n\n      & > *:not(:last-child) {\n        margin-right: ", ";\n      }\n    "]);

    _templateObject2 = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject() {
    const data = _taggedTemplateLiteral(["\n      ", ";\n\n      display: inline-flex;\n      justify-content: center;\n      align-items: center;\n\n      appearance: none;\n      outline: none;\n      background: transparent;\n      border: none;\n      border-radius: ", ";\n      text-decoration: none;\n      cursor: pointer;\n\n      &:disabled {\n        cursor: not-allowed;\n      }\n    "]);

    _templateObject = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles = reactStyleSystem.createStyles(({
    css,
    theme,
    color,
    surface
  }) => {
    const mixWithSurface = (color, amount) => reactStyleSystem.mix(color, surface, amount);

    return {
      // button base styles
      root: css(_templateObject(), theme.button, theme.borderRadius),
      // shapes
      standard: css(_templateObject2(), theme.block(1), theme.space(1)),
      icon: css(_templateObject3(), theme.space(1.25), theme.space(1.25)),
      // variants
      outlined: css(_templateObject4(), color.readable, color.readable, theme.duration.standard, theme.duration.standard, mixWithSurface(color.decorative, 0.92), mixWithSurface(color.decorative, 0.9), mixWithSurface(color.decorative, 0.8), mixWithSurface(color.readable, 0.4)),
      filled: css(_templateObject5(), color.decorative, reactStyleSystem.readableColor(color.decorative), theme.duration.standard, theme.duration.standard, mixWithSurface(color.decorative, 0.18), reactStyleSystem.transparentize('#fff', 0.7), mixWithSurface(color.decorative, 0.23), mixWithSurface(color.decorative, 0.3), reactStyleSystem.transparentize('#fff', 0.5), mixWithSurface(color.decorative, 0.5), mixWithSurface(reactStyleSystem.readableColor(color.decorative), 0.2)),
      ghost: css(_templateObject6(), color.readable, theme.duration.standard, theme.duration.standard, reactStyleSystem.transparentize(color.decorative, 0.92), reactStyleSystem.transparentize(reactStyleSystem.readableColor(color.decorative), 0.8), reactStyleSystem.transparentize(color.decorative, 0.9), reactStyleSystem.transparentize(color.decorative, 0.8), reactStyleSystem.transparentize(color.readable, 0.4)),
      // sizes
      standardSmall: css(_templateObject7(), theme.space(0.5), theme.space(0.75), theme.block(0.75)),
      standardStandard: css(_templateObject8(), theme.space(0.75), theme.space(1), theme.block(1)),
      standardLarge: css(_templateObject9(), theme.space(1), theme.space(1.25), theme.block(1.5)),
      iconSmall: css(_templateObject10(), theme.space(2), theme.space(2)),
      iconStandard: css(_templateObject11(), theme.space(2.5), theme.space(2.5)),
      iconLarge: css(_templateObject12(), theme.space(3), theme.space(3))
    };
  });
  const Button = React.forwardRef((props, ref) => {
    const _useStyles = useStyles(props, props.component || 'button'),
          {
      Root,
      styles,
      component,
      variant = 'ghost',
      size = 'standard',
      shape = 'standard'
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "component", "variant", "size", "shape"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      className: classNames('hui-button', {
        [styles.icon]: shape === 'icon',
        [styles.standard]: shape === 'standard',
        [styles.outlined]: variant === 'outlined',
        [styles.ghost]: variant === 'ghost',
        [styles.filled]: variant === 'filled',
        [styles.iconSmall]: shape === 'icon' && size === 'small',
        [styles.iconStandard]: shape === 'icon' && size === 'standard',
        [styles.iconLarge]: shape === 'icon' && size === 'large',
        [styles.standardSmall]: shape === 'standard' && size === 'small',
        [styles.standardStandard]: shape === 'standard' && size === 'standard',
        [styles.standardLarge]: shape === 'standard' && size === 'large'
      }),
      ref: ref
    }, restOfProps));
  });
  Button.displayName = 'Button';

  function _templateObject$1() {
    const data = _taggedTemplateLiteral(["\n    list-style-type: none;\n    padding: 0;\n    margin: 0;\n  "]);

    _templateObject$1 = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$1 = reactStyleSystem.createStyles(({
    css
  }) => ({
    root: css(_templateObject$1())
  }));
  const List = React.forwardRef((props, ref) => {
    const _useStyles = useStyles$1(props, 'ul' ),
          {
      Root,
      styles
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref
    }, restOfProps));
  });
  List.displayName = 'List';

  function _templateObject$2() {
    const data = _taggedTemplateLiteral(["\n    ", ";\n    display: flex;\n  "]);

    _templateObject$2 = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$2 = reactStyleSystem.createStyles(({
    css,
    theme
  }) => ({
    root: css(_templateObject$2(), theme.body2)
  }));
  const ListItem = React.forwardRef((props, ref) => {
    const _useStyles = useStyles$2(props, 'li'),
          {
      Root,
      styles
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref
    }, restOfProps));
  });
  ListItem.displayName = 'ListItem';

  function _templateObject18() {
    const data = _taggedTemplateLiteral(["\n      ", ";\n      ", " {\n        ", ";\n      }\n    "]);

    _templateObject18 = function _templateObject18() {
      return data;
    };

    return data;
  }

  function _templateObject17() {
    const data = _taggedTemplateLiteral(["\n      ", ";\n      ", " {\n        ", ";\n      }\n    "]);

    _templateObject17 = function _templateObject17() {
      return data;
    };

    return data;
  }

  function _templateObject16() {
    const data = _taggedTemplateLiteral(["\n      ", ";\n      ", " {\n        ", ";\n      }\n    "]);

    _templateObject16 = function _templateObject16() {
      return data;
    };

    return data;
  }

  function _templateObject15() {
    const data = _taggedTemplateLiteral(["\n      ", ";\n      ", " {\n        ", ";\n      }\n    "]);

    _templateObject15 = function _templateObject15() {
      return data;
    };

    return data;
  }

  function _templateObject14() {
    const data = _taggedTemplateLiteral(["\n      ", ";\n      ", " {\n        ", ";\n      }\n    "]);

    _templateObject14 = function _templateObject14() {
      return data;
    };

    return data;
  }

  function _templateObject13() {
    const data = _taggedTemplateLiteral(["\n      font-size: 12px;\n      font-weight: 400;\n      letter-spacing: 1.2px;\n      text-transform: uppercase;\n      margin: 0;\n    "]);

    _templateObject13 = function _templateObject13() {
      return data;
    };

    return data;
  }

  function _templateObject12$1() {
    const data = _taggedTemplateLiteral(["\n      font-size: 14px;\n      font-weight: normal;\n      text-transform: none;\n      margin: 0;\n    "]);

    _templateObject12$1 = function _templateObject12() {
      return data;
    };

    return data;
  }

  function _templateObject11$1() {
    const data = _taggedTemplateLiteral(["\n      font-size: 0.75em;\n      font-weight: bold;\n      text-transform: uppercase;\n      margin: 0;\n    "]);

    _templateObject11$1 = function _templateObject11() {
      return data;
    };

    return data;
  }

  function _templateObject10$1() {
    const data = _taggedTemplateLiteral(["\n      font-size: 16px;\n      text-transform: none;\n      line-height: 1.5;\n      font-weight: 400;\n      margin: 0;\n    "]);

    _templateObject10$1 = function _templateObject10() {
      return data;
    };

    return data;
  }

  function _templateObject9$1() {
    const data = _taggedTemplateLiteral(["\n      font-size: 18px;\n      line-height: 1.6;\n      letter-spacing: -0.333px;\n      text-transform: none;\n      font-weight: 400;\n      margin: 0;\n    "]);

    _templateObject9$1 = function _templateObject9() {
      return data;
    };

    return data;
  }

  function _templateObject8$1() {
    const data = _taggedTemplateLiteral(["\n      font-size: 14px;\n      font-weight: bold;\n      text-transform: none;\n      margin: 0;\n    "]);

    _templateObject8$1 = function _templateObject8() {
      return data;
    };

    return data;
  }

  function _templateObject7$1() {
    const data = _taggedTemplateLiteral(["\n      font-size: 16px;\n      text-transform: none;\n      margin: 0;\n    "]);

    _templateObject7$1 = function _templateObject7() {
      return data;
    };

    return data;
  }

  function _templateObject6$1() {
    const data = _taggedTemplateLiteral(["\n      font-size: 18px;\n      font-weight: bold;\n      text-transform: none;\n      margin: 0;\n    "]);

    _templateObject6$1 = function _templateObject6() {
      return data;
    };

    return data;
  }

  function _templateObject5$1() {
    const data = _taggedTemplateLiteral(["\n      font-size: 28px;\n      letter-spacing: -0.3px;\n      font-weight: bold;\n      text-transform: none;\n      margin: 0;\n    "]);

    _templateObject5$1 = function _templateObject5() {
      return data;
    };

    return data;
  }

  function _templateObject4$1() {
    const data = _taggedTemplateLiteral(["\n      font-size: 42px;\n      letter-spacing: -0.3px;\n      font-weight: bold;\n      text-transform: none;\n      margin: 0;\n    "]);

    _templateObject4$1 = function _templateObject4() {
      return data;
    };

    return data;
  }

  function _templateObject3$1() {
    const data = _taggedTemplateLiteral(["\n      font-size: 60px;\n      letter-spacing: -0.3px;\n      font-weight: bold;\n      text-transform: none;\n      margin: 0;\n    "]);

    _templateObject3$1 = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2$1() {
    const data = _taggedTemplateLiteral(["\n      font-size: 96px;\n      letter-spacing: -2px;\n      font-weight: bold;\n      text-transform: none;\n      margin: 0;\n    "]);

    _templateObject2$1 = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$3() {
    const data = _taggedTemplateLiteral(["\n      font-size: 144px;\n      letter-spacing: -3px;\n      font-weight: bold;\n      text-transform: none;\n      margin: 0;\n    "]);

    _templateObject$3 = function _templateObject() {
      return data;
    };

    return data;
  }

  const parsePx = value => {
    const match = value.match(/([\d.]+)px.*/i);

    if (!match) {
      throw new Error("Expected value to have px units. Got: \"".concat(value, "\""));
    }

    return parseFloat(match[1]);
  };

  const defaultTheme = {
    // media queries
    media: {
      up(value) {
        console.log('this value', this[value]);
        return "@media (min-width: ".concat(parsePx(this[value]) + 1, "px)");
      },

      down(value) {
        console.log('this value', this[value]);
        return "@media (max-width: ".concat(this[value], ")");
      },

      between(min, max) {
        return "@media (max-width: ".concat(this[min], ") and (min-width: ").concat(parsePx(this[max]) + 1, "px)");
      },

      mobile: '425px',
      tablet: '768px',
      desktop: '1024px',
      desktopLarge: '1440px'
    },
    // non-responsive font-sizes
    fontStatic: {
      h1: reactStyleSystem.css(_templateObject$3()),
      h2: reactStyleSystem.css(_templateObject2$1()),
      h3: reactStyleSystem.css(_templateObject3$1()),
      h4: reactStyleSystem.css(_templateObject4$1()),
      h5: reactStyleSystem.css(_templateObject5$1()),
      h6: reactStyleSystem.css(_templateObject6$1()),
      subtitle1: reactStyleSystem.css(_templateObject7$1()),
      subtitle2: reactStyleSystem.css(_templateObject8$1()),
      body1: reactStyleSystem.css(_templateObject9$1()),
      body2: reactStyleSystem.css(_templateObject10$1()),
      button: reactStyleSystem.css(_templateObject11$1()),
      caption: reactStyleSystem.css(_templateObject12$1()),
      overline: reactStyleSystem.css(_templateObject13())
    },
    weight: {
      light: 300,
      normal: 400,
      semiBold: 600,
      bold: 700,
      black: 900
    },

    // responsive/default font-sizes
    get h1() {
      return reactStyleSystem.css(_templateObject14(), this.fontStatic.h1, this.media.down('tablet'), this.fontStatic.h2);
    },

    get h2() {
      return reactStyleSystem.css(_templateObject15(), this.fontStatic.h2, this.media.down('tablet'), this.fontStatic.h3);
    },

    get h3() {
      return reactStyleSystem.css(_templateObject16(), this.fontStatic.h3, this.media.down('tablet'), this.fontStatic.h4);
    },

    get h4() {
      return reactStyleSystem.css(_templateObject17(), this.fontStatic.h4, this.media.down('tablet'), this.fontStatic.h5);
    },

    get h5() {
      return this.fontStatic.h5;
    },

    get h6() {
      return this.fontStatic.h6;
    },

    get subtitle1() {
      return this.fontStatic.subtitle1;
    },

    get subtitle2() {
      return this.fontStatic.subtitle2;
    },

    get body1() {
      return reactStyleSystem.css(_templateObject18(), this.fontStatic.body1, this.media.down('mobile'), this.fontStatic.body2);
    },

    get body2() {
      return this.fontStatic.body2;
    },

    get caption() {
      return this.fontStatic.caption;
    },

    get button() {
      return this.fontStatic.button;
    },

    get overline() {
      return this.fontStatic.overline;
    },

    // colors
    surface: '#fff',
    brand: '#000',

    get accent() {
      const accent = '#2962ff';
      return reactStyleSystem.readableColorIsBlack(this.surface) ? accent : reactStyleSystem.lighten(accent, 0.1);
    },

    get danger() {
      const danger = '#eb002b';
      return reactStyleSystem.readableColorIsBlack(this.surface) ? danger : reactStyleSystem.lighten(danger, 0.2);
    },

    warning: '#f56200',

    get bland() {
      return reactStyleSystem.readableColorIsBlack(this.surface) ? '#ccc' : '#555';
    },

    // z-indexes
    zIndex: {
      appBar: 1100,
      drawer: 1200,
      modal: 1300,
      notification: 1400,
      tooltip: 1500
    },
    // border-radius
    borderRadius: '2px',
    // spacing unit helpers
    space: n => "".concat(n * 16, "px"),
    gap: n => "".concat(n * 48, "px"),
    block: n => "".concat(n * 96, "px"),
    // durations
    duration: {
      short: '100ms',
      standard: '250ms',
      long: '500ms'
    },
    // shadows
    shadows: {
      subtle: '0 0 10px 0 rgba(0,0,0,0.10)',
      standard: '0 0 20px 0 rgba(0,0,0,0.13)',
      emphasis: '0 0 30px 0 rgba(0,0,0,0.13)'
    }
  };

  function ThemeProvider({
    theme = defaultTheme,
    children
  }) {
    return /*#__PURE__*/React__default.createElement(reactStyleSystem.ThemeProvider, {
      theme: theme
    }, /*#__PURE__*/React__default.createElement(reactStyleSystem.ColorContextProvider, {
      color: theme.accent,
      surface: theme.surface
    }, children));
  }

  function isObject(maybe) {
    if (!maybe) return false;
    return typeof maybe === 'object';
  }
  /**
   * recursively merges a base object with an incoming object
   */


  function recursiveMerge(base, incoming) {
    const keys = [...Object.keys(base), ...Object.keys(incoming)];
    const merged = keys.reduce((merged, key) => {
      var _baseDescriptor$get, _incomingDescriptor$g;

      const baseValue = base[key];
      const incomingValue = incoming[key];

      if (isObject(baseValue) || isObject(incomingValue)) {
        merged[key] = recursiveMerge(baseValue || {}, incomingValue || {});
        return merged;
      }

      const baseDescriptor = Object.getOwnPropertyDescriptor(base, key);
      const incomingDescriptor = Object.getOwnPropertyDescriptor(incoming, key);
      const baseGetter = baseDescriptor === null || baseDescriptor === void 0 ? void 0 : (_baseDescriptor$get = baseDescriptor.get) === null || _baseDescriptor$get === void 0 ? void 0 : _baseDescriptor$get.bind(merged);
      const incomingGetter = incomingDescriptor === null || incomingDescriptor === void 0 ? void 0 : (_incomingDescriptor$g = incomingDescriptor.get) === null || _incomingDescriptor$g === void 0 ? void 0 : _incomingDescriptor$g.bind(merged);
      const incomingIsValue = incomingDescriptor && 'value' in incomingDescriptor || false;

      if (incomingIsValue) {
        // TODO: test if this is needed
        if (typeof incomingValue === 'function') {
          merged[key] = incomingValue.bind(merged);
          return merged;
        }

        merged[key] = incomingValue;
        return merged;
      }

      if (incomingGetter) {
        Object.defineProperty(merged, key, {
          get: incomingGetter,
          enumerable: true,
          configurable: true
        });
        return merged;
      }

      if (baseGetter) {
        Object.defineProperty(merged, key, {
          get: baseGetter,
          enumerable: true,
          configurable: true
        });
        return merged;
      } // TODO: test if this is needed


      if (typeof baseValue === 'function') {
        merged[key] = baseValue.bind(merged);
        return merged;
      }

      merged[key] = baseValue;
      return merged;
    }, {});
    return merged;
  }

  function createTheme(partialTheme) {
    return recursiveMerge(defaultTheme, partialTheme || {});
  }

  function _templateObject$4() {
    const data = _taggedTemplateLiteral(["\n    ", ";\n    align-items: flex-start;\n    width: 100%;\n    display: flex;\n    flex-direction: column;\n  "]);

    _templateObject$4 = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$3 = reactStyleSystem.createStyles(({
    css,
    theme
  }) => ({
    root: css(_templateObject$4(), theme.body2)
  }));
  const ListItemButton = React.forwardRef((props, ref) => {
    const theme = reactStyleSystem.useTheme();

    const _useStyles = useStyles$3(props, Button),
          {
      Root,
      styles
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref,
      variant: "ghost",
      color: theme.bland
    }, restOfProps));
  });
  ListItemButton.displayName = 'ListItemButton';

  function _templateObject$5() {
    const data = _taggedTemplateLiteral(["\n    color: ", ";\n    text-decoration: none;\n    transition: color ", ";\n\n    &:hover {\n      text-decoration: underline;\n    }\n\n    &:active {\n      color: ", ";\n    }\n  "]);

    _templateObject$5 = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$4 = reactStyleSystem.createStyles(({
    css,
    theme,
    color,
    surface
  }) => ({
    root: css(_templateObject$5(), color.readable, theme.duration.standard, reactStyleSystem.mix(color.readable, surface, 0.3))
  }));
  const Anchor = React.forwardRef((props, ref) => {
    var _props$component;

    const _useStyles = useStyles$4(props, (_props$component = props.component) !== null && _props$component !== void 0 ? _props$component : 'a'),
          {
      Root,
      styles,
      component
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "component"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      className: "hui-anchor",
      ref: ref
    }, restOfProps));
  });
  Anchor.displayName = 'Anchor';

  var FormControlContext = React.createContext(null);

  function _templateObject$6() {
    const data = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: column;\n  "]);

    _templateObject$6 = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$5 = reactStyleSystem.createStyles(({
    css
  }) => ({
    root: css(_templateObject$6())
  }));
  const FormControl = React.forwardRef((props, ref) => {
    var _ref, _props$color, _ref2, _props$surface;

    const _useStyles = useStyles$5(props, props.component || 'div'),
          {
      Root,
      styles,
      component,
      hasError = false,
      disabled = false
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "component", "hasError", "disabled"]);

    const colorContext = reactStyleSystem.useColorContext();
    const theme = reactStyleSystem.useTheme();
    const color = (_ref = (_props$color = props.color) !== null && _props$color !== void 0 ? _props$color : colorContext === null || colorContext === void 0 ? void 0 : colorContext.color.original) !== null && _ref !== void 0 ? _ref : theme.accent;
    const surface = (_ref2 = (_props$surface = props.surface) !== null && _props$surface !== void 0 ? _props$surface : colorContext === null || colorContext === void 0 ? void 0 : colorContext.surface) !== null && _ref2 !== void 0 ? _ref2 : theme.surface;
    const id = React.useMemo(() => "hui-".concat(uid()), []);
    const [focused, setFocused] = React.useState(false);
    const formControlContextValue = React.useMemo(() => ({
      id,
      focused,
      setFocused,
      hasError,
      disabled
    }), [disabled, focused, hasError, id]);
    return /*#__PURE__*/React__default.createElement(reactStyleSystem.ColorContextProvider, {
      color: color,
      surface: surface
    }, /*#__PURE__*/React__default.createElement(FormControlContext.Provider, {
      value: formControlContextValue
    }, /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref
    }, restOfProps))));
  });
  FormControl.displayName = 'FormControl';

  function _templateObject4$2() {
    const data = _taggedTemplateLiteral(["\n      color: ", ";\n      cursor: not-allowed;\n    "]);

    _templateObject4$2 = function _templateObject4() {
      return data;
    };

    return data;
  }

  function _templateObject3$2() {
    const data = _taggedTemplateLiteral(["\n      color: ", ";\n    "]);

    _templateObject3$2 = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2$2() {
    const data = _taggedTemplateLiteral(["\n      color: ", ";\n    "]);

    _templateObject2$2 = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$7() {
    const data = _taggedTemplateLiteral(["\n      ", ";\n      color: ", ";\n      transition: color ", ";\n      cursor: pointer;\n    "]);

    _templateObject$7 = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$6 = reactStyleSystem.createStyles(({
    css,
    theme,
    color,
    surface
  }) => {
    const bland = reactStyleSystem.createReadablePalette(theme.bland, surface);
    return {
      root: css(_templateObject$7(), theme.body1, reactStyleSystem.readableColor(theme.surface), theme.duration.standard),
      focused: css(_templateObject2$2(), color.readable),
      hasError: css(_templateObject3$2(), theme.danger),
      disabled: css(_templateObject4$2(), reactStyleSystem.mix(bland.readable, surface, 0.3))
    };
  });
  const Label = React.forwardRef((props, ref) => {
    var _ref, _ref2, _ref3;

    const _useStyles = useStyles$6(props, props.component || 'label'),
          {
      Root,
      styles,
      component,
      id: incomingId,
      focused: incomingFocused,
      hasError: incomingHasError,
      disabled: incomingDisabled
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "component", "id", "focused", "hasError", "disabled"]);

    const formControlContext = React.useContext(FormControlContext);
    const id = incomingId !== null && incomingId !== void 0 ? incomingId : formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.id;
    const focused = (_ref = incomingFocused !== null && incomingFocused !== void 0 ? incomingFocused : formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.focused) !== null && _ref !== void 0 ? _ref : false;
    const hasError = (_ref2 = incomingHasError !== null && incomingHasError !== void 0 ? incomingHasError : formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.hasError) !== null && _ref2 !== void 0 ? _ref2 : false;
    const disabled = (_ref3 = incomingDisabled !== null && incomingDisabled !== void 0 ? incomingDisabled : formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.disabled) !== null && _ref3 !== void 0 ? _ref3 : false;
    return /*#__PURE__*/React__default.createElement(Root, _extends({
      className: classNames({
        [styles.focused]: focused,
        [styles.hasError]: hasError,
        [styles.disabled]: disabled
      }),
      ref: ref,
      htmlFor: id
    }, restOfProps));
  });
  Label.displayName = 'Label';

  function _templateObject5$2() {
    const data = _taggedTemplateLiteral(["\n      border: 2px solid ", ";\n      &:focus {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      &:not([disabled]):hover {\n        border: 2px solid ", ";\n      }\n    "]);

    _templateObject5$2 = function _templateObject5() {
      return data;
    };

    return data;
  }

  function _templateObject4$3() {
    const data = _taggedTemplateLiteral(["\n      background-color: ", ";\n      transition: border ", ",\n        background-color ", ";\n      border: 2px solid ", ";\n\n      &:focus {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      &:hover {\n        border: 2px solid ", ";\n      }\n      &:disabled {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n    "]);

    _templateObject4$3 = function _templateObject4() {
      return data;
    };

    return data;
  }

  function _templateObject3$3() {
    const data = _taggedTemplateLiteral(["\n      background-color: ", ";\n      color: ", ";\n      &:focus {\n        background-color: ", ";\n      }\n      &:not([disabled]):hover {\n        background-color: ", ";\n      }\n    "]);

    _templateObject3$3 = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2$3() {
    const data = _taggedTemplateLiteral(["\n      background-color: ", ";\n      color: ", ";\n      transition: background-color ", ";\n\n      &:focus {\n        background-color: ", ";\n        color: ", ";\n      }\n      &:hover {\n        background-color: ", ";\n        color: ", ";\n      }\n      &:disabled {\n        background-color: ", ";\n      }\n    "]);

    _templateObject2$3 = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$8() {
    const data = _taggedTemplateLiteral(["\n      ", ";\n      padding: ", " ", ";\n      border: none;\n      outline: none;\n      appearance: none;\n      background: none;\n      margin: ", " 0;\n      border-radius: ", ";\n      color: ", ";\n\n      &::placeholder {\n        color: ", ";\n      }\n\n      &:disabled {\n        cursor: not-allowed;\n      }\n    "]);

    _templateObject$8 = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$7 = reactStyleSystem.createStyles(({
    css,
    theme,
    color,
    surface
  }) => {
    const mixWithSurface = (color, amount) => reactStyleSystem.mix(color, surface, amount);

    const bland = reactStyleSystem.createReadablePalette(theme.bland, surface);
    const danger = reactStyleSystem.createReadablePalette(theme.danger, surface);
    return {
      root: css(_templateObject$8(), theme.body1, theme.space(0.75), theme.space(0.5), theme.space(0.5), theme.borderRadius, reactStyleSystem.readableColor(theme.surface), mixWithSurface(reactStyleSystem.readableColor(theme.surface), 0.25)),
      filled: css(_templateObject2$3(), mixWithSurface(bland.decorative, 0.8), reactStyleSystem.readableColor(surface), theme.duration.standard, mixWithSurface(color.decorative, 0.92), reactStyleSystem.readableColor(surface), mixWithSurface(color.decorative, 0.9), reactStyleSystem.readableColor(surface), mixWithSurface(bland.decorative, 0.9)),
      filledHasError: css(_templateObject3$3(), mixWithSurface(danger.decorative, 0.9), reactStyleSystem.readableColor(surface), mixWithSurface(danger.decorative, 0.85), mixWithSurface(danger.decorative, 0.87)),
      outlined: css(_templateObject4$3(), surface, theme.duration.standard, theme.duration.standard, bland.decorative, color.decorative, mixWithSurface(color.decorative, 0.93), reactStyleSystem.transparentize(color.decorative, 0.3), reactStyleSystem.transparentize(bland.decorative, 0.7), mixWithSurface(bland.decorative, 0.9)),
      outlinedHasError: css(_templateObject5$2(), danger.decorative, danger.decorative, mixWithSurface(danger.decorative, 0.93), reactStyleSystem.transparentize(danger.decorative, 0.3))
    };
  });
  const TextInput = React.forwardRef((props, ref) => {
    var _props$component;

    const _useStyles = useStyles$7(props, (_props$component = props.component) !== null && _props$component !== void 0 ? _props$component : 'input'),
          {
      Root,
      styles,
      variant = 'outlined',
      hasError: incomingHasError,
      disabled: incomingDisabled,
      onFocus,
      onBlur,
      type = 'text'
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "variant", "hasError", "disabled", "onFocus", "onBlur", "type"]);

    const formControlContext = React.useContext(FormControlContext);
    const id = formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.id;
    const disabled = Boolean(formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.disabled) || Boolean(incomingDisabled);
    const hasError = Boolean(formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.hasError) || Boolean(incomingHasError);

    const handleFocus = e => {
      if (onFocus) {
        onFocus(e);
      }

      if (formControlContext) {
        formControlContext.setFocused(true);
      }
    };

    const handleBlur = e => {
      if (onBlur) {
        onBlur(e);
      }

      if (formControlContext) {
        formControlContext.setFocused(false);
      }
    };

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref,
      id: id,
      type: type,
      disabled: disabled,
      className: classNames({
        [styles.outlined]: variant === 'outlined',
        [styles.outlinedHasError]: variant === 'outlined' && hasError,
        [styles.filled]: variant === 'filled',
        [styles.filledHasError]: variant === 'filled' && hasError
      }),
      onFocus: handleFocus,
      onBlur: handleBlur
    }, restOfProps));
  });
  TextInput.displayName = 'TextInput';

  function _templateObject4$4() {
    const data = _taggedTemplateLiteral(["\n      color: ", ";\n      cursor: not-allowed;\n    "]);

    _templateObject4$4 = function _templateObject4() {
      return data;
    };

    return data;
  }

  function _templateObject3$4() {
    const data = _taggedTemplateLiteral(["\n      color: ", ";\n    "]);

    _templateObject3$4 = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2$4() {
    const data = _taggedTemplateLiteral(["\n      color: ", ";\n    "]);

    _templateObject2$4 = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$9() {
    const data = _taggedTemplateLiteral(["\n      ", ";\n      transition: color ", ";\n    "]);

    _templateObject$9 = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$8 = reactStyleSystem.createStyles(({
    css,
    color,
    theme,
    surface
  }) => {
    const bland = reactStyleSystem.createReadablePalette(theme.bland, surface);
    return {
      root: css(_templateObject$9(), theme.caption, theme.duration.standard),
      focused: css(_templateObject2$4(), color.readable),
      hasError: css(_templateObject3$4(), theme.danger),
      disabled: css(_templateObject4$4(), reactStyleSystem.mix(bland.readable, surface, 0.3))
    };
  });
  const HelperText = React.forwardRef((props, ref) => {
    var _props$component, _ref, _ref2, _ref3;

    const formControlContext = React.useContext(FormControlContext);

    const _useStyles = useStyles$8(props, (_props$component = props.component) !== null && _props$component !== void 0 ? _props$component : 'div'),
          {
      Root,
      styles,
      component,
      focused: incomingFocused,
      hasError: incomingHasError,
      disabled: incomingDisabled
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "component", "focused", "hasError", "disabled"]);

    const focused = (_ref = incomingFocused !== null && incomingFocused !== void 0 ? incomingFocused : formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.focused) !== null && _ref !== void 0 ? _ref : false;
    const hasError = (_ref2 = incomingHasError !== null && incomingHasError !== void 0 ? incomingHasError : formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.hasError) !== null && _ref2 !== void 0 ? _ref2 : false;
    const disabled = (_ref3 = incomingDisabled !== null && incomingDisabled !== void 0 ? incomingDisabled : formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.disabled) !== null && _ref3 !== void 0 ? _ref3 : false;
    return /*#__PURE__*/React__default.createElement(Root, _extends({
      className: classNames({
        [styles.focused]: focused,
        [styles.hasError]: hasError,
        [styles.disabled]: disabled
      }),
      ref: ref
    }, restOfProps));
  });
  HelperText.displayName = 'HelperText';

  function _templateObject5$3() {
    const data = _taggedTemplateLiteral(["\n      border: 2px solid ", ";\n      &:focus {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      &:not([disabled]):hover {\n        border: 2px solid ", ";\n      }\n    "]);

    _templateObject5$3 = function _templateObject5() {
      return data;
    };

    return data;
  }

  function _templateObject4$5() {
    const data = _taggedTemplateLiteral(["\n      background-color: ", ";\n      transition: border ", ",\n        background-color ", ";\n      border: 2px solid ", ";\n\n      &:focus {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      &:hover {\n        border: 2px solid ", ";\n      }\n      &:disabled {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n    "]);

    _templateObject4$5 = function _templateObject4() {
      return data;
    };

    return data;
  }

  function _templateObject3$5() {
    const data = _taggedTemplateLiteral(["\n      background-color: ", ";\n      color: ", ";\n      &:focus {\n        background-color: ", ";\n      }\n      &:not([disabled]):hover {\n        background-color: ", ";\n      }\n    "]);

    _templateObject3$5 = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2$5() {
    const data = _taggedTemplateLiteral(["\n      background-color: ", ";\n      color: ", ";\n      transition: background-color ", ";\n\n      &:focus {\n        background-color: ", ";\n        color: ", ";\n      }\n      &:hover {\n        background-color: ", ";\n        color: ", ";\n      }\n      &:disabled {\n        background-color: ", ";\n      }\n    "]);

    _templateObject2$5 = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$a() {
    const data = _taggedTemplateLiteral(["\n      ", ";\n      color: ", ";\n      padding: ", " ", ";\n      border: none;\n      outline: none;\n      appearance: none;\n      background: none;\n      margin: ", " 0;\n      border-radius: ", ";\n\n      &::placeholder {\n        color: ", ";\n      }\n\n      &:disabled {\n        cursor: not-allowed;\n      }\n    "]);

    _templateObject$a = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$9 = reactStyleSystem.createStyles(({
    css,
    theme,
    color,
    surface
  }) => {
    const mixWithSurface = (color, amount) => reactStyleSystem.mix(color, surface, amount);

    const bland = reactStyleSystem.createReadablePalette(theme.bland, surface);
    const danger = reactStyleSystem.createReadablePalette(theme.danger, surface);
    return {
      root: css(_templateObject$a(), theme.body1, reactStyleSystem.readableColor(theme.surface), theme.space(0.75), theme.space(0.5), theme.space(0.5), theme.borderRadius, mixWithSurface(reactStyleSystem.readableColor(theme.surface), 0.25)),
      filled: css(_templateObject2$5(), mixWithSurface(bland.decorative, 0.8), reactStyleSystem.readableColor(surface), theme.duration.standard, mixWithSurface(color.decorative, 0.92), reactStyleSystem.readableColor(surface), mixWithSurface(color.decorative, 0.9), reactStyleSystem.readableColor(surface), mixWithSurface(bland.decorative, 0.9)),
      filledHasError: css(_templateObject3$5(), mixWithSurface(danger.decorative, 0.9), reactStyleSystem.readableColor(surface), mixWithSurface(danger.decorative, 0.85), mixWithSurface(danger.decorative, 0.87)),
      outlined: css(_templateObject4$5(), surface, theme.duration.standard, theme.duration.standard, bland.decorative, color.decorative, mixWithSurface(color.decorative, 0.93), reactStyleSystem.transparentize(color.decorative, 0.3), reactStyleSystem.transparentize(bland.decorative, 0.7), mixWithSurface(bland.decorative, 0.9)),
      outlinedHasError: css(_templateObject5$3(), danger.decorative, danger.decorative, mixWithSurface(danger.decorative, 0.93), reactStyleSystem.transparentize(danger.decorative, 0.3))
    };
  });
  const TextArea = React.forwardRef((props, ref) => {
    var _props$component, _ref, _formControlContext$d;

    const _useStyles = useStyles$9(props, (_props$component = props.component) !== null && _props$component !== void 0 ? _props$component : 'textarea'),
          {
      Root,
      styles,
      variant = 'outlined',
      focused: _focused,
      hasError: incomingHasError,
      disabled: incomingDisabled,
      onFocus,
      onBlur
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "variant", "focused", "hasError", "disabled", "onFocus", "onBlur"]);

    const formControlContext = React.useContext(FormControlContext);
    const id = formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.id;
    const hasError = (_ref = incomingHasError !== null && incomingHasError !== void 0 ? incomingHasError : formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.hasError) !== null && _ref !== void 0 ? _ref : false;
    const disabledFromFormControl = (_formControlContext$d = formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.disabled) !== null && _formControlContext$d !== void 0 ? _formControlContext$d : false;
    const disabled = incomingDisabled || disabledFromFormControl;

    const handleFocus = e => {
      if (onFocus) {
        onFocus(e);
      }

      if (formControlContext) {
        formControlContext.setFocused(true);
      }
    };

    const handleBlur = e => {
      if (onBlur) {
        onBlur(e);
      }

      if (formControlContext) {
        formControlContext.setFocused(false);
      }
    };

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref,
      id: id,
      disabled: disabled,
      className: classNames({
        [styles.outlined]: variant === 'outlined',
        [styles.outlinedHasError]: variant === 'outlined' && hasError,
        [styles.filled]: variant === 'filled',
        [styles.filledHasError]: variant === 'filled' && hasError
      }),
      onFocus: handleFocus,
      onBlur: handleBlur
    }, restOfProps));
  });
  TextArea.displayName = 'TextArea';

  const CheckIcon = React.forwardRef((props, ref) => {
    return /*#__PURE__*/React__default.createElement("svg", _extends({
      ref: ref,
      "aria-hidden": "true",
      viewBox: "0 0 512 512"
    }, props), /*#__PURE__*/React__default.createElement("path", {
      fill: "currentColor",
      d: "M173.898 439.404l-166.4-166.4c-9.997-9.997-9.997-26.206 0-36.204l36.203-36.204c9.997-9.998 26.207-9.998 36.204 0L192 312.69 432.095 72.596c9.997-9.997 26.207-9.997 36.204 0l36.203 36.204c9.997 9.997 9.997 26.206 0 36.204l-294.4 294.401c-9.998 9.997-26.207 9.997-36.204-.001z"
    }));
  });
  CheckIcon.displayName = 'CheckIcon';

  function _templateObject11$2() {
    const data = _taggedTemplateLiteral(["\n      width: 1rem;\n      height: 1rem;\n      fill: currentColor;\n      opacity: 0;\n      pointer-events: none;\n    "]);

    _templateObject11$2 = function _templateObject11() {
      return data;
    };

    return data;
  }

  function _templateObject10$2() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject10$2 = function _templateObject10() {
      return data;
    };

    return data;
  }

  function _templateObject9$2() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject9$2 = function _templateObject9() {
      return data;
    };

    return data;
  }

  function _templateObject8$2() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject8$2 = function _templateObject8() {
      return data;
    };

    return data;
  }

  function _templateObject7$2() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n      display: flex;\n      justify-content: center;\n      align-items: center;\n      flex: 0 0 auto;\n      background-color: white;\n      transition: border ", ",\n        background-color ", ";\n      border: 2px solid ", ";\n      background-color: ", ";\n      border-radius: ", ";\n    "]);

    _templateObject7$2 = function _templateObject7() {
      return data;
    };

    return data;
  }

  function _templateObject6$2() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject6$2 = function _templateObject6() {
      return data;
    };

    return data;
  }

  function _templateObject5$4() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject5$4 = function _templateObject5() {
      return data;
    };

    return data;
  }

  function _templateObject4$6() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject4$6 = function _templateObject4() {
      return data;
    };

    return data;
  }

  function _templateObject3$6() {
    const data = _taggedTemplateLiteral(["\n      cursor: pointer;\n      opacity: 0;\n      position: absolute;\n      top: 0;\n      left: 0;\n\n      &:focus ~ .facade {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      &:hover ~ .facade {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      &:active ~ .facade {\n        background-color: ", ";\n      }\n\n      &:disabled ~ .facade {\n        cursor: not-allowed;\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n\n      &:disabled {\n        cursor: not-allowed;\n      }\n\n      &:checked ~ .facade .icon {\n        opacity: 1;\n      }\n    "]);

    _templateObject3$6 = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2$6() {
    const data = _taggedTemplateLiteral(["\n      color: ", ";\n      & .facade {\n        border: 2px solid ", ";\n      }\n      & .checkbox:focus ~ .facade {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      & .checkbox:not([disabled]):hover ~ .facade {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      & .checkbox:active ~ .facade {\n        background-color: ", ";\n      }\n    "]);

    _templateObject2$6 = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$b() {
    const data = _taggedTemplateLiteral(["\n      position: relative;\n      margin: ", " 0;\n      background-color: ", ";\n    "]);

    _templateObject$b = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$a = reactStyleSystem.createStyles(({
    css,
    color,
    theme,
    surface
  }) => {
    const mixWithSurface = (color, amount) => reactStyleSystem.mix(color, surface, amount);

    const bland = reactStyleSystem.createReadablePalette(theme.bland, surface);
    const danger = reactStyleSystem.createReadablePalette(theme.danger, surface);
    const width = theme.space(2);
    const height = theme.space(2);
    const widthSmall = theme.space(1.5);
    const heightSmall = theme.space(1.5);
    const widthLarge = theme.space(2.5);
    const heightLarge = theme.space(2.5);
    return {
      root: css(_templateObject$b(), theme.space(0.5), surface),
      hasError: css(_templateObject2$6(), danger.decorative, danger.decorative, danger.decorative, mixWithSurface(danger.decorative, 0.93), reactStyleSystem.transparentize(danger.decorative, 0.3), mixWithSurface(danger.decorative, 0.93), mixWithSurface(danger.decorative, 0.9)),
      checkbox: css(_templateObject3$6(), color.decorative, mixWithSurface(color.decorative, 0.93), reactStyleSystem.transparentize(color.decorative, 0.3), mixWithSurface(color.decorative, 0.93), mixWithSurface(color.decorative, 0.9), reactStyleSystem.transparentize(bland.decorative, 0.7), mixWithSurface(bland.decorative, 0.9)),
      checkboxStandard: css(_templateObject4$6(), width, height),
      checkboxSmall: css(_templateObject5$4(), widthSmall, heightSmall),
      checkboxLarge: css(_templateObject6$2(), widthLarge, heightLarge),
      facade: css(_templateObject7$2(), width, height, theme.duration.standard, theme.duration.standard, bland.decorative, surface, theme.borderRadius),
      facadeSmall: css(_templateObject8$2(), widthSmall, heightSmall),
      facadeStandard: css(_templateObject9$2(), width, height),
      facadeLarge: css(_templateObject10$2(), widthLarge, heightLarge),
      icon: css(_templateObject11$2())
    };
  });
  const Checkbox = React.forwardRef((props, ref) => {
    const _useStyles = useStyles$a(props),
          {
      Root,
      styles,
      id: incomingId,
      hasError: incomingHasError,
      disabled: incomingDisabled,
      onFocus,
      onBlur,
      inputRef,
      icon: Icon = CheckIcon,
      size = 'standard'
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "id", "hasError", "disabled", "onFocus", "onBlur", "inputRef", "icon", "size"]);

    const formControlContext = React.useContext(FormControlContext);
    const id = incomingId !== null && incomingId !== void 0 ? incomingId : formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.id;
    const hasError = Boolean(formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.hasError) || Boolean(incomingHasError);
    const disabled = Boolean(formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.disabled) || Boolean(incomingDisabled);

    const handleFocus = e => {
      if (onFocus) {
        onFocus(e);
      }

      if (formControlContext) {
        formControlContext.setFocused(true);
      }
    };

    const handleBlur = e => {
      if (onBlur) {
        onBlur(e);
      }

      if (formControlContext) {
        formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.setFocused(false);
      }
    };

    return /*#__PURE__*/React__default.createElement(Root, {
      ref: ref,
      className: classNames({
        [styles.hasError]: hasError
      })
    }, /*#__PURE__*/React__default.createElement("input", _extends({
      type: "checkbox",
      id: id,
      ref: inputRef,
      className: classNames('checkbox', styles.checkbox, {
        [styles.checkboxSmall]: size === 'small',
        [styles.checkboxStandard]: size === 'standard',
        [styles.checkboxLarge]: size === 'large'
      }),
      onFocus: handleFocus,
      onBlur: handleBlur,
      disabled: disabled
    }, restOfProps)), /*#__PURE__*/React__default.createElement("div", {
      "aria-hidden": "true",
      className: classNames('facade', styles.facade, {
        [styles.facadeSmall]: size === 'small',
        [styles.facadeStandard]: size === 'standard',
        [styles.facadeLarge]: size === 'large'
      })
    }, /*#__PURE__*/React__default.createElement(Icon, {
      className: classNames('icon', styles.icon)
    })));
  });
  Checkbox.displayName = 'Checkbox';

  var RadioGroupContext = React.createContext(null);

  const CircleIcon = React.forwardRef((props, ref) => {
    return /*#__PURE__*/React__default.createElement("svg", _extends({
      ref: ref,
      "aria-hidden": "true",
      viewBox: "0 0 512 512"
    }, props), /*#__PURE__*/React__default.createElement("circle", {
      cx: "256",
      cy: "256",
      fill: "currentColor",
      r: "192"
    }));
  });
  CircleIcon.displayName = 'CircleIcon';

  function _templateObject11$3() {
    const data = _taggedTemplateLiteral(["\n      width: 1rem;\n      height: 1rem;\n      fill: currentColor;\n      opacity: 0;\n      pointer-events: none;\n    "]);

    _templateObject11$3 = function _templateObject11() {
      return data;
    };

    return data;
  }

  function _templateObject10$3() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject10$3 = function _templateObject10() {
      return data;
    };

    return data;
  }

  function _templateObject9$3() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject9$3 = function _templateObject9() {
      return data;
    };

    return data;
  }

  function _templateObject8$3() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject8$3 = function _templateObject8() {
      return data;
    };

    return data;
  }

  function _templateObject7$3() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n      border-radius: 99999px;\n      display: flex;\n      justify-content: center;\n      align-items: center;\n      flex: 0 0 auto;\n      background-color: white;\n      transition: border ", ",\n        background-color ", ";\n      border: 2px solid ", ";\n      background-color: ", ";\n    "]);

    _templateObject7$3 = function _templateObject7() {
      return data;
    };

    return data;
  }

  function _templateObject6$3() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject6$3 = function _templateObject6() {
      return data;
    };

    return data;
  }

  function _templateObject5$5() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject5$5 = function _templateObject5() {
      return data;
    };

    return data;
  }

  function _templateObject4$7() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject4$7 = function _templateObject4() {
      return data;
    };

    return data;
  }

  function _templateObject3$7() {
    const data = _taggedTemplateLiteral(["\n      cursor: pointer;\n      opacity: 0;\n      position: absolute;\n      top: 0;\n      left: 0;\n\n      &:focus ~ .facade {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      &:hover ~ .facade {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      &:active ~ .facade {\n        background-color: ", ";\n      }\n\n      &:disabled ~ .facade {\n        cursor: not-allowed;\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n\n      &:disabled {\n        cursor: not-allowed;\n      }\n\n      &:checked ~ .facade .icon {\n        opacity: 1;\n      }\n    "]);

    _templateObject3$7 = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2$7() {
    const data = _taggedTemplateLiteral(["\n      color: ", ";\n      & .facade {\n        border: 2px solid ", ";\n      }\n      & .radio:focus ~ .facade {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      & .radio:not([disabled]):hover ~ .facade {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      & .radio:active ~ .facade {\n        background-color: ", ";\n      }\n    "]);

    _templateObject2$7 = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$c() {
    const data = _taggedTemplateLiteral(["\n      position: relative;\n      margin: ", " 0;\n    "]);

    _templateObject$c = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$b = reactStyleSystem.createStyles(({
    css,
    color,
    theme,
    surface
  }) => {
    const mixWithSurface = (color, amount) => reactStyleSystem.mix(color, surface, amount);

    const bland = reactStyleSystem.createReadablePalette(theme.bland, surface);
    const danger = reactStyleSystem.createReadablePalette(theme.danger, surface);
    const width = theme.space(2);
    const height = theme.space(2);
    const widthSmall = theme.space(1.5);
    const heightSmall = theme.space(1.5);
    const widthLarge = theme.space(2.5);
    const heightLarge = theme.space(2.5);
    return {
      root: css(_templateObject$c(), theme.space(0.5)),
      hasError: css(_templateObject2$7(), danger.decorative, danger.decorative, danger.decorative, mixWithSurface(danger.decorative, 0.93), reactStyleSystem.transparentize(danger.decorative, 0.3), mixWithSurface(danger.decorative, 0.93), mixWithSurface(danger.decorative, 0.9)),
      radio: css(_templateObject3$7(), color.decorative, mixWithSurface(color.decorative, 0.93), reactStyleSystem.transparentize(color.decorative, 0.3), mixWithSurface(color.decorative, 0.93), mixWithSurface(color.decorative, 0.9), reactStyleSystem.transparentize(bland.decorative, 0.7), mixWithSurface(bland.decorative, 0.9)),
      radioStandard: css(_templateObject4$7(), width, height),
      radioSmall: css(_templateObject5$5(), widthSmall, heightSmall),
      radioLarge: css(_templateObject6$3(), widthLarge, heightLarge),
      facade: css(_templateObject7$3(), width, height, theme.duration.standard, theme.duration.standard, bland.decorative, surface),
      facadeSmall: css(_templateObject8$3(), widthSmall, heightSmall),
      facadeStandard: css(_templateObject9$3(), width, height),
      facadeLarge: css(_templateObject10$3(), widthLarge, heightLarge),
      icon: css(_templateObject11$3())
    };
  });
  const Radio = React.forwardRef((props, ref) => {
    const _useStyles = useStyles$b(props),
          {
      Root,
      styles,
      id: incomingId,
      hasError: incomingHasError,
      disabled: incomingDisabled,
      checked: incomingChecked,
      name: incomingName,
      value,
      onFocus,
      onBlur,
      onChange,
      inputRef,
      icon: Icon = CircleIcon,
      size = 'standard'
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "id", "hasError", "disabled", "checked", "name", "value", "onFocus", "onBlur", "onChange", "inputRef", "icon", "size"]);

    const formControlContext = React.useContext(FormControlContext);
    const radioGroupContext = React.useContext(RadioGroupContext);
    const id = incomingId !== null && incomingId !== void 0 ? incomingId : formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.id;
    const hasError = Boolean(formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.hasError) || Boolean(incomingHasError);
    const disabled = Boolean(formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.disabled) || Boolean(incomingDisabled);
    const checkedFromContext = radioGroupContext ? radioGroupContext.value === value : undefined;
    const checked = incomingChecked !== null && incomingChecked !== void 0 ? incomingChecked : checkedFromContext;
    const name = incomingName !== null && incomingName !== void 0 ? incomingName : radioGroupContext === null || radioGroupContext === void 0 ? void 0 : radioGroupContext.name;

    const handleFocus = e => {
      if (onFocus) {
        onFocus(e);
      }

      if (formControlContext) {
        formControlContext.setFocused(true);
      }
    };

    const handleBlur = e => {
      if (onBlur) {
        onBlur(e);
      }

      if (formControlContext) {
        formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.setFocused(false);
      }
    };

    const handleChange = e => {
      if (onChange) {
        onChange(e);
      }

      if (radioGroupContext) {
        radioGroupContext.handleChange(e);
      }
    };

    return /*#__PURE__*/React__default.createElement(Root, {
      ref: ref,
      className: classNames({
        [styles.hasError]: hasError
      })
    }, /*#__PURE__*/React__default.createElement("input", _extends({
      type: "radio",
      id: id,
      ref: inputRef,
      value: value,
      name: name,
      checked: checked,
      className: classNames('radio', styles.radio, {
        [styles.radioSmall]: size === 'small',
        [styles.radioStandard]: size === 'standard',
        [styles.radioLarge]: size === 'large'
      }),
      onFocus: handleFocus,
      onBlur: handleBlur,
      onChange: handleChange,
      disabled: disabled
    }, restOfProps)), /*#__PURE__*/React__default.createElement("div", {
      "aria-hidden": "true",
      className: classNames('facade', styles.facade, {
        [styles.facadeSmall]: size === 'small',
        [styles.facadeStandard]: size === 'standard',
        [styles.facadeLarge]: size === 'large'
      })
    }, /*#__PURE__*/React__default.createElement(Icon, {
      className: classNames('icon', styles.icon)
    })));
  });
  Radio.displayName = 'Radio';

  function _templateObject$d() {
    const data = _taggedTemplateLiteral([""]);

    _templateObject$d = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$c = reactStyleSystem.createStyles(({
    css
  }) => ({
    root: css(_templateObject$d())
  }));
  const RadioGroup = React.forwardRef((props, ref) => {
    var _props$component;

    const _useStyles = useStyles$c(props, (_props$component = props.component) !== null && _props$component !== void 0 ? _props$component : 'div'),
          {
      Root,
      styles,
      component,
      value: incomingValue,
      onChange
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "component", "value", "onChange"]);

    const name = React.useMemo(() => "hui-group-".concat(uid()), []);
    const [stateValue, setStateValue] = React.useState('');
    const value = incomingValue !== null && incomingValue !== void 0 ? incomingValue : stateValue; // pull the reference of onChange on invocation

    const onChangeRef = React.useRef(onChange);
    const handleChange = React.useCallback(e => {
      const onChange = onChangeRef.current;

      if (onChange) {
        onChange(e);
      }

      setStateValue(e.currentTarget.value);
    }, []);
    const contextValue = React.useMemo(() => ({
      name,
      value,
      handleChange
    }), [handleChange, name, value]);
    return /*#__PURE__*/React__default.createElement(RadioGroupContext.Provider, {
      value: contextValue
    }, /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref,
      role: "radiogroup"
    }, restOfProps)));
  });
  RadioGroup.displayName = 'RadioGroup';

  function _templateObject15$1() {
    const data = _taggedTemplateLiteral(["\n      r: 40;\n    "]);

    _templateObject15$1 = function _templateObject15() {
      return data;
    };

    return data;
  }

  function _templateObject14$1() {
    const data = _taggedTemplateLiteral(["\n      r: 35;\n    "]);

    _templateObject14$1 = function _templateObject14() {
      return data;
    };

    return data;
  }

  function _templateObject13$1() {
    const data = _taggedTemplateLiteral(["\n      r: 30;\n    "]);

    _templateObject13$1 = function _templateObject13() {
      return data;
    };

    return data;
  }

  function _templateObject12$2() {
    const data = _taggedTemplateLiteral(["\n      transition: cx ", ", fill ", ";\n    "]);

    _templateObject12$2 = function _templateObject12() {
      return data;
    };

    return data;
  }

  function _templateObject11$4() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n      fill: currentColor;\n      pointer-events: none;\n    "]);

    _templateObject11$4 = function _templateObject11() {
      return data;
    };

    return data;
  }

  function _templateObject10$4() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject10$4 = function _templateObject10() {
      return data;
    };

    return data;
  }

  function _templateObject9$4() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject9$4 = function _templateObject9() {
      return data;
    };

    return data;
  }

  function _templateObject8$4() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject8$4 = function _templateObject8() {
      return data;
    };

    return data;
  }

  function _templateObject7$4() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n      border-radius: 99999px;\n      display: flex;\n      justify-content: center;\n      align-items: center;\n      flex: 0 0 auto;\n      background-color: white;\n      transition: border ", ",\n        background-color ", ";\n      border: 2px solid ", ";\n      background-color: ", ";\n    "]);

    _templateObject7$4 = function _templateObject7() {
      return data;
    };

    return data;
  }

  function _templateObject6$4() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject6$4 = function _templateObject6() {
      return data;
    };

    return data;
  }

  function _templateObject5$6() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject5$6 = function _templateObject5() {
      return data;
    };

    return data;
  }

  function _templateObject4$8() {
    const data = _taggedTemplateLiteral(["\n      width: ", ";\n      height: ", ";\n    "]);

    _templateObject4$8 = function _templateObject4() {
      return data;
    };

    return data;
  }

  function _templateObject3$8() {
    const data = _taggedTemplateLiteral(["\n      cursor: pointer;\n      opacity: 0;\n      position: absolute;\n      top: 0;\n      left: 0;\n\n      &:focus ~ .facade {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      &:hover ~ .facade {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      &:active ~ .facade {\n        background-color: ", ";\n      }\n\n      &:disabled ~ .facade {\n        cursor: not-allowed;\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n\n      &:disabled {\n        cursor: not-allowed;\n      }\n\n      &:checked ~ .facade .dot {\n        cx: 125;\n        fill: ", ";\n      }\n\n      &:disabled ~ .facade .dot {\n        fill: ", ";\n      }\n\n      &:checked ~ .facade {\n        background-color: ", ";\n      }\n    "]);

    _templateObject3$8 = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2$8() {
    const data = _taggedTemplateLiteral(["\n      color: ", ";\n      & .facade {\n        border: 2px solid ", ";\n      }\n      & .switch:focus ~ .facade {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      & .switch:not([disabled]):hover ~ .facade {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      & .switch:active ~ .facade {\n        background-color: ", ";\n      }\n\n      & .switch:checked ~ .facade {\n        background-color: ", ";\n      }\n\n      & .switch:checked ~ .facade .dot {\n        fill: ", ";\n      }\n    "]);

    _templateObject2$8 = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$e() {
    const data = _taggedTemplateLiteral(["\n      position: relative;\n      margin: ", " 0;\n      background-color: ", ";\n      border-radius: 99999px;\n    "]);

    _templateObject$e = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$d = reactStyleSystem.createStyles(({
    css,
    color,
    theme,
    surface
  }) => {
    const mixWithSurface = (color, amount) => reactStyleSystem.mix(color, surface, amount);

    const bland = reactStyleSystem.createReadablePalette(theme.bland, surface);
    const danger = reactStyleSystem.createReadablePalette(theme.danger, surface);
    const width = theme.space(3.5);
    const height = theme.space(2);
    const widthSmall = theme.space(2.75);
    const heightSmall = theme.space(1.5);
    const widthLarge = theme.space(4);
    const heightLarge = theme.space(2.5);
    return {
      root: css(_templateObject$e(), theme.space(0.5), surface),
      hasError: css(_templateObject2$8(), danger.decorative, danger.decorative, danger.decorative, mixWithSurface(danger.decorative, 0.93), reactStyleSystem.transparentize(danger.decorative, 0.3), mixWithSurface(danger.decorative, 0.93), mixWithSurface(danger.decorative, 0.9), mixWithSurface(danger.decorative, 0.93), danger.decorative),
      switch: css(_templateObject3$8(), color.decorative, mixWithSurface(color.decorative, 0.93), reactStyleSystem.transparentize(color.decorative, 0.3), mixWithSurface(color.decorative, 0.93), mixWithSurface(color.decorative, 0.9), reactStyleSystem.transparentize(bland.decorative, 0.7), mixWithSurface(bland.decorative, 0.9), color.decorative, bland.decorative, mixWithSurface(color.decorative, 0.9)),
      switchStandard: css(_templateObject4$8(), width, height),
      switchSmall: css(_templateObject5$6(), widthSmall, heightSmall),
      switchLarge: css(_templateObject6$4(), widthLarge, heightLarge),
      facade: css(_templateObject7$4(), width, height, theme.duration.standard, theme.duration.standard, bland.decorative, surface),
      facadeSmall: css(_templateObject8$4(), widthSmall, heightSmall),
      facadeStandard: css(_templateObject9$4(), width, height),
      facadeLarge: css(_templateObject10$4(), widthLarge, heightLarge),
      icon: css(_templateObject11$4(), width, height),
      dot: css(_templateObject12$2(), theme.duration.standard, theme.duration.standard),
      dotSmall: css(_templateObject13$1()),
      dotStandard: css(_templateObject14$1()),
      dotLarge: css(_templateObject15$1())
    };
  });
  const Switch = React.forwardRef((props, ref) => {
    const _useStyles = useStyles$d(props),
          {
      Root,
      styles,
      id: incomingId,
      hasError: incomingHasError,
      disabled: incomingDisabled,
      onFocus,
      onBlur,
      inputRef,
      size = 'standard'
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "id", "hasError", "disabled", "onFocus", "onBlur", "inputRef", "size"]);

    const formControlContext = React.useContext(FormControlContext);
    const id = incomingId !== null && incomingId !== void 0 ? incomingId : formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.id;
    const hasError = Boolean(formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.hasError) || Boolean(incomingHasError);
    const disabled = Boolean(formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.disabled) || Boolean(incomingDisabled);

    const handleFocus = e => {
      if (onFocus) {
        onFocus(e);
      }

      if (formControlContext) {
        formControlContext.setFocused(true);
      }
    };

    const handleBlur = e => {
      if (onBlur) {
        onBlur(e);
      }

      if (formControlContext) {
        formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.setFocused(false);
      }
    };

    return /*#__PURE__*/React__default.createElement(Root, {
      ref: ref,
      className: classNames({
        [styles.hasError]: hasError
      })
    }, /*#__PURE__*/React__default.createElement("input", _extends({
      type: "checkbox",
      id: id,
      ref: inputRef,
      className: classNames('switch', styles.switch, {
        [styles.switchSmall]: size === 'small',
        [styles.switchStandard]: size === 'standard',
        [styles.switchLarge]: size === 'large'
      }),
      onFocus: handleFocus,
      onBlur: handleBlur,
      disabled: disabled
    }, restOfProps)), /*#__PURE__*/React__default.createElement("div", {
      "aria-hidden": "true",
      className: classNames('facade', styles.facade, {
        [styles.facadeSmall]: size === 'small',
        [styles.facadeStandard]: size === 'standard',
        [styles.facadeLarge]: size === 'large'
      })
    }, /*#__PURE__*/React__default.createElement("svg", {
      className: styles.icon,
      viewBox: "0 0 175 100"
    }, /*#__PURE__*/React__default.createElement("circle", {
      className: classNames('dot', styles.dot, {
        [styles.dotSmall]: size === 'small',
        [styles.dotStandard]: size === 'standard',
        [styles.dotLarge]: size === 'large'
      }),
      cx: "50",
      cy: "50"
    }))));
  });
  Switch.displayName = 'Switch';

  const AngleDownIcon = React.forwardRef((props, ref) => {
    return /*#__PURE__*/React__default.createElement("svg", _extends({
      ref: ref,
      "aria-hidden": "true",
      viewBox: "0 0 320 512"
    }, props), /*#__PURE__*/React__default.createElement("path", {
      fill: "currentColor",
      d: "M143 352.3L7 216.3c-9.4-9.4-9.4-24.6 0-33.9l22.6-22.6c9.4-9.4 24.6-9.4 33.9 0l96.4 96.4 96.4-96.4c9.4-9.4 24.6-9.4 33.9 0l22.6 22.6c9.4 9.4 9.4 24.6 0 33.9l-136 136c-9.2 9.4-24.4 9.4-33.8 0z"
    }));
  });
  AngleDownIcon.displayName = 'AngleDownIcon';

  function _templateObject7$5() {
    const data = _taggedTemplateLiteral(["\n      pointer-events: none;\n      width: ", ";\n      height: ", ";\n      position: absolute;\n      right: ", ";\n      top: 50%;\n      transform: translateY(-50%);\n    "]);

    _templateObject7$5 = function _templateObject7() {
      return data;
    };

    return data;
  }

  function _templateObject6$5() {
    const data = _taggedTemplateLiteral(["\n      border: 2px solid ", ";\n      &:focus {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      &:not([disabled]):hover {\n        border: 2px solid ", ";\n      }\n    "]);

    _templateObject6$5 = function _templateObject6() {
      return data;
    };

    return data;
  }

  function _templateObject5$7() {
    const data = _taggedTemplateLiteral(["\n      background-color: ", ";\n      transition: border ", ",\n        background-color ", ",\n        color ", ";\n      border: 2px solid ", ";\n      color: ", ";\n\n      &:focus {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n      &:hover {\n        border: 2px solid ", ";\n      }\n      &:disabled {\n        border: 2px solid ", ";\n        background-color: ", ";\n      }\n    "]);

    _templateObject5$7 = function _templateObject5() {
      return data;
    };

    return data;
  }

  function _templateObject4$9() {
    const data = _taggedTemplateLiteral(["\n      background-color: ", ";\n      color: ", ";\n      &:focus {\n        background-color: ", ";\n      }\n      &:not([disabled]):hover {\n        background-color: ", ";\n      }\n    "]);

    _templateObject4$9 = function _templateObject4() {
      return data;
    };

    return data;
  }

  function _templateObject3$9() {
    const data = _taggedTemplateLiteral(["\n      background-color: ", ";\n      color: ", ";\n      transition: background-color ", ";\n\n      &:focus {\n        background-color: ", ";\n        color: ", ";\n      }\n      &:hover {\n        background-color: ", ";\n        color: ", ";\n      }\n      &:disabled {\n        background-color: ", ";\n      }\n    "]);

    _templateObject3$9 = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2$9() {
    const data = _taggedTemplateLiteral(["\n      ", ";\n      width: 100%;\n      height: 100%;\n      appearance: none;\n      outline: none;\n      border: none;\n      background: none;\n      padding: ", " ", ";\n      border-radius: ", ";\n      cursor: pointer;\n\n      &:disabled {\n        cursor: not-allowed;\n      }\n    "]);

    _templateObject2$9 = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$f() {
    const data = _taggedTemplateLiteral(["\n      position: relative;\n      margin: ", " 0;\n    "]);

    _templateObject$f = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$e = reactStyleSystem.createStyles(({
    css,
    theme,
    color,
    surface
  }) => {
    const mixWithSurface = (color, amount) => reactStyleSystem.mix(color, surface, amount);

    const bland = reactStyleSystem.createReadablePalette(theme.bland, surface);
    const danger = reactStyleSystem.createReadablePalette(theme.danger, surface);
    return {
      root: css(_templateObject$f(), theme.space(0.5)),
      select: css(_templateObject2$9(), theme.body1, theme.space(0.75), theme.space(0.5), theme.borderRadius),
      selectFilled: css(_templateObject3$9(), mixWithSurface(bland.decorative, 0.8), reactStyleSystem.readableColor(surface), theme.duration.standard, mixWithSurface(color.decorative, 0.92), reactStyleSystem.readableColor(surface), mixWithSurface(color.decorative, 0.9), reactStyleSystem.readableColor(surface), mixWithSurface(bland.decorative, 0.9)),
      selectFilledHasError: css(_templateObject4$9(), mixWithSurface(danger.decorative, 0.9), reactStyleSystem.readableColor(surface), mixWithSurface(danger.decorative, 0.85), mixWithSurface(danger.decorative, 0.87)),
      selectOutlined: css(_templateObject5$7(), surface, theme.duration.standard, theme.duration.standard, theme.duration.standard, bland.decorative, reactStyleSystem.readableColor(surface), color.decorative, mixWithSurface(color.decorative, 0.93), reactStyleSystem.transparentize(color.decorative, 0.3), reactStyleSystem.transparentize(bland.decorative, 0.7), mixWithSurface(bland.decorative, 0.9)),
      selectedOutlinedHasError: css(_templateObject6$5(), danger.decorative, danger.decorative, mixWithSurface(danger.decorative, 0.93), reactStyleSystem.transparentize(danger.decorative, 0.3)),
      icon: css(_templateObject7$5(), theme.space(1), theme.space(1), theme.space(0.75))
    };
  });
  const Select = React.forwardRef((props, ref) => {
    var _props$component;

    const formControlContext = React.useContext(FormControlContext);

    const _useStyles = useStyles$e(props, (_props$component = props.component) !== null && _props$component !== void 0 ? _props$component : 'div'),
          {
      Root,
      id: incomingId,
      styles,
      component,
      selectRef,
      disabled: incomingDisabled,
      hasError: incomingHasError,
      onFocus,
      onBlur,
      variant = 'outlined'
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "id", "styles", "component", "selectRef", "disabled", "hasError", "onFocus", "onBlur", "variant"]);

    const disabled = Boolean(formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.disabled) || Boolean(incomingDisabled);
    const hasError = Boolean(formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.hasError) || Boolean(incomingHasError);
    const id = incomingId !== null && incomingId !== void 0 ? incomingId : formControlContext === null || formControlContext === void 0 ? void 0 : formControlContext.id;

    const handleFocus = e => {
      if (onFocus) {
        onFocus(e);
      }

      if (formControlContext) {
        formControlContext.setFocused(true);
      }
    };

    const handleBlur = e => {
      if (onBlur) {
        onBlur(e);
      }

      if (formControlContext) {
        formControlContext.setFocused(false);
      }
    };

    return /*#__PURE__*/React__default.createElement(Root, {
      ref: ref
    }, /*#__PURE__*/React__default.createElement("select", _extends({
      id: id,
      ref: selectRef,
      className: classNames(styles.select, {
        [styles.selectFilled]: variant === 'filled',
        [styles.selectFilledHasError]: variant === 'filled' && hasError,
        [styles.selectOutlined]: variant === 'outlined',
        [styles.selectedOutlinedHasError]: variant === 'outlined' && hasError
      }),
      disabled: disabled,
      onFocus: handleFocus,
      onBlur: handleBlur
    }, restOfProps)), /*#__PURE__*/React__default.createElement(AngleDownIcon, {
      className: styles.icon
    }));
  });
  Select.displayName = 'Select';

  function _templateObject5$8() {
    const data = _taggedTemplateLiteral(["\n      cursor: pointer;\n      &:focus {\n        background-color: ", ";\n        border: 2px solid ", ";\n      }\n      &:hover {\n        background-color: ", ";\n      }\n      &:active {\n        background-color: ", ";\n        border: 2px solid ", ";\n      }\n    "]);

    _templateObject5$8 = function _templateObject5() {
      return data;
    };

    return data;
  }

  function _templateObject4$a() {
    const data = _taggedTemplateLiteral(["\n      background-color: ", ";\n      color: ", ";\n      border: 2px solid transparent;\n      transition: background-color ", ",\n        border ", ";\n\n      &:disabled {\n        background-color: ", ";\n        border: 2px solid transparent;\n        color: ", ";\n      }\n    "]);

    _templateObject4$a = function _templateObject4() {
      return data;
    };

    return data;
  }

  function _templateObject3$a() {
    const data = _taggedTemplateLiteral(["\n      cursor: pointer;\n      &:focus {\n        background-color: ", ";\n      }\n      &:hover {\n        background-color: ", ";\n      }\n      &:active {\n        background-color: ", ";\n      }\n    "]);

    _templateObject3$a = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2$a() {
    const data = _taggedTemplateLiteral(["\n      border: 1px solid ", ";\n      color: ", ";\n\n      transition: background-color ", ",\n        border ", ";\n\n      &:disabled {\n        &,\n        &:hover,\n        &:focus {\n          color: ", ";\n          background-color: transparent;\n        }\n      }\n    "]);

    _templateObject2$a = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$g() {
    const data = _taggedTemplateLiteral(["\n      ", "\n      font-weight: bold;\n\n      display: inline-flex;\n      justify-content: center;\n      align-items: center;\n\n      appearance: none;\n      outline: none;\n      background: transparent;\n      border: none;\n      text-decoration: none;\n      border-radius: 999999px;\n      min-height: 34px;\n\n      &:disabled {\n        cursor: not-allowed;\n      }\n\n      padding: ", " ", ";\n\n      & > *:not(:last-child) {\n        margin-right: ", ";\n      }\n\n      & > .hui-button {\n        margin-top: ", ";\n        margin-bottom: ", ";\n        margin-right: ", ";\n        margin-left: ", ";\n      }\n    "]);

    _templateObject$g = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$f = reactStyleSystem.createStyles(({
    css,
    theme,
    color,
    surface
  }) => {
    const mixWithSurface = (color, amount) => reactStyleSystem.mix(color, surface, amount);

    return {
      // button base styles
      root: css(_templateObject$g(), theme.caption, theme.space(0.5), theme.space(0.75), theme.space(0.5), "-".concat(theme.space(0.5)), "-".concat(theme.space(0.5)), "-".concat(theme.space(0.75)), "-".concat(theme.space(0.25))),
      // variants
      outlined: css(_templateObject2$a(), color.readable, color.readable, theme.duration.standard, theme.duration.standard, mixWithSurface(color.readable, 0.4)),
      outlinedClickable: css(_templateObject3$a(), mixWithSurface(color.decorative, 0.92), mixWithSurface(color.decorative, 0.9), mixWithSurface(color.decorative, 0.8)),
      filled: css(_templateObject4$a(), color.decorative, reactStyleSystem.readableColor(color.decorative), theme.duration.standard, theme.duration.standard, mixWithSurface(color.decorative, 0.5), mixWithSurface(reactStyleSystem.readableColor(color.decorative), 0.2)),
      filledClickable: css(_templateObject5$8(), mixWithSurface(color.decorative, 0.18), reactStyleSystem.transparentize('#fff', 0.7), mixWithSurface(color.decorative, 0.23), mixWithSurface(color.decorative, 0.3), reactStyleSystem.transparentize('#fff', 0.5))
    };
  });
  const Chip = React.forwardRef((props, ref) => {
    var _props$component, _props$color, _props$surface;

    const component = ((_props$component = props.component) !== null && _props$component !== void 0 ? _props$component : props.clickable) ? 'button' : 'div';

    const _useStyles = useStyles$f(props, component),
          {
      Root,
      styles,
      component: _component,
      clickable,
      variant = 'outlined'
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "component", "clickable", "variant"]);

    const colorContext = reactStyleSystem.useColorContext();
    let color = (_props$color = props.color) !== null && _props$color !== void 0 ? _props$color : colorContext === null || colorContext === void 0 ? void 0 : colorContext.color.original;
    let surface = (_props$surface = props.surface) !== null && _props$surface !== void 0 ? _props$surface : colorContext === null || colorContext === void 0 ? void 0 : colorContext.surface;

    if (variant === 'filled') {
      surface = color;
      color = reactStyleSystem.readableColor(surface);
    }

    return /*#__PURE__*/React__default.createElement(reactStyleSystem.ColorContextProvider, {
      surface: surface,
      color: color
    }, /*#__PURE__*/React__default.createElement(Root, _extends({
      className: classNames({
        [styles.outlined]: variant === 'outlined',
        [styles.outlinedClickable]: variant === 'outlined' && clickable,
        [styles.filled]: variant === 'filled',
        [styles.filledClickable]: variant === 'filled' && clickable
      }),
      ref: ref
    }, restOfProps)));
  });
  Chip.displayName = 'Chip';

  function _templateObject$h() {
    const data = _taggedTemplateLiteral(["\n    width: ", ";\n    height: ", ";\n    margin-top: ", ";\n    margin-bottom: ", ";\n    margin-left: ", ";\n    border-radius: 99999px;\n    overflow: hidden;\n\n    display: flex;\n    align-items: center;\n    justify-content: center;\n\n    & > img {\n      width: 100%;\n      height: 100%;\n      object-fit: cover;\n    }\n\n    & > svg {\n      width: ", ";\n      height: ", ";\n    }\n  "]);

    _templateObject$h = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$g = reactStyleSystem.createStyles(({
    css,
    theme
  }) => ({
    root: css(_templateObject$h(), theme.space(1.5), theme.space(1.5), "-".concat(theme.space(0.5)), "-".concat(theme.space(0.5)), "-".concat(theme.space(0.5)), theme.space(1), theme.space(1))
  }));
  const ChipThumbnail = React.forwardRef((props, ref) => {
    var _props$component;

    const _useStyles = useStyles$g(props, (_props$component = props.component) !== null && _props$component !== void 0 ? _props$component : 'div'),
          {
      Root,
      styles,
      component
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "component"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref
    }, restOfProps));
  });
  ChipThumbnail.displayName = 'ChipThumbnail';

  const TimesIcon = React.forwardRef((props, ref) => {
    return /*#__PURE__*/React__default.createElement("svg", _extends({
      ref: ref,
      "aria-hidden": "true",
      viewBox: "0 0 352 512"
    }, props), /*#__PURE__*/React__default.createElement("path", {
      fill: "currentColor",
      d: "M242.72 256l100.07-100.07c12.28-12.28 12.28-32.19 0-44.48l-22.24-22.24c-12.28-12.28-32.19-12.28-44.48 0L176 189.28 75.93 89.21c-12.28-12.28-32.19-12.28-44.48 0L9.21 111.45c-12.28 12.28-12.28 32.19 0 44.48L109.28 256 9.21 356.07c-12.28 12.28-12.28 32.19 0 44.48l22.24 22.24c12.28 12.28 32.2 12.28 44.48 0L176 322.72l100.07 100.07c12.28 12.28 32.2 12.28 44.48 0l22.24-22.24c12.28-12.28 12.28-32.19 0-44.48L242.72 256z"
    }));
  });
  TimesIcon.displayName = 'TimesIcon';

  function delay(milliseconds) {
    return new Promise(resolve => setTimeout(() => resolve('delay'), milliseconds));
  }

  function useDebounce(value, delay) {
    // State and setters for debounced value
    const [debouncedValue, setDebouncedValue] = React.useState(value);
    React.useEffect(() => {
      // Update debounced value after delay
      const handler = setTimeout(() => {
        setDebouncedValue(value);
      }, delay); // Cancel the timeout if value changes (also on delay change or unmount)
      // This is how we prevent debounced value from updating if value is changed ...
      // .. within the delay period. Timeout gets cleared and restarted.

      return () => {
        clearTimeout(handler);
      };
    }, [value, delay] // Only re-call effect if value or delay changes
    );
    return debouncedValue;
  }

  function _templateObject6$6() {
    const data = _taggedTemplateLiteral(["\n    position: fixed;\n    pointer-events: none;\n    width: 100vw;\n    height: 100vh;\n    top: 0;\n    left: 0;\n  "]);

    _templateObject6$6 = function _templateObject6() {
      return data;
    };

    return data;
  }

  function _templateObject5$9() {
    const data = _taggedTemplateLiteral(["\n    transform: translate(0, -50%);\n  "]);

    _templateObject5$9 = function _templateObject5() {
      return data;
    };

    return data;
  }

  function _templateObject4$b() {
    const data = _taggedTemplateLiteral(["\n    transform: translate(-50%, 0);\n  "]);

    _templateObject4$b = function _templateObject4() {
      return data;
    };

    return data;
  }

  function _templateObject3$b() {
    const data = _taggedTemplateLiteral(["\n    transform: translate(-100%, -50%);\n  "]);

    _templateObject3$b = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2$b() {
    const data = _taggedTemplateLiteral(["\n    transform: translate(-50%, -100%);\n  "]);

    _templateObject2$b = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$i() {
    const data = _taggedTemplateLiteral(["\n    ", ";\n    position: absolute;\n    pointer-events: auto;\n    padding: ", " ", ";\n    min-width: ", ";\n    text-align: center;\n    color: ", ";\n    background-color: ", ";\n    z-index: ", ";\n  "]);

    _templateObject$i = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$h = reactStyleSystem.createStyles(({
    css,
    theme,
    surface
  }) => ({
    root: css(_templateObject$i(), theme.caption, theme.space(0.5), theme.space(1), theme.block(1), reactStyleSystem.readableColor(reactStyleSystem.readableColor(surface)), reactStyleSystem.mix(reactStyleSystem.readableColor(surface), surface, 0.2), theme.zIndex.tooltip),
    top: css(_templateObject2$b()),
    left: css(_templateObject3$b()),
    bottom: css(_templateObject4$b()),
    right: css(_templateObject5$9()),
    tooltipContainer: css(_templateObject6$6())
  }));

  function Tooltip(props) {
    const {
      Root,
      styles,
      title,
      children,
      position = 'top'
    } = useStyles$h(props);
    const rootRef = React.useRef(null);
    const [isMouseOverRoot, setIsMouseOverRoot] = React.useState(false);
    const [isMouseOverTooltip, setIsMouseOverTooltip] = React.useState(false); // TODO: this would be better as one object

    const [top, setTop] = React.useState(0);
    const [left, setLeft] = React.useState(0);
    const [width, setWidth] = React.useState(0);
    const [height, setHeight] = React.useState(0);
    const margin = 8;
    let tooltipTop;
    let tooltipLeft;
    const topCenter = top + height / 2;
    const leftCenter = left + width / 2;

    if (position === 'left') {
      tooltipTop = topCenter;
      tooltipLeft = left - margin;
    } else if (position === 'right') {
      tooltipTop = topCenter;
      tooltipLeft = left + width + margin;
    } else if (position === 'bottom') {
      tooltipTop = top + height + margin;
      tooltipLeft = leftCenter;
    } else {
      // position === 'top'
      tooltipTop = top - margin;
      tooltipLeft = leftCenter;
    }

    const [tooltipContainer, setTooltipContainer] = React.useState(null);
    const isMouseOver = isMouseOverRoot || isMouseOverTooltip;
    const debouncedMouseOver = useDebounce(isMouseOver, 500); // remove the tooltip container on scroll

    React.useEffect(() => {
      const handleScroll = () => {
        setTooltipContainer(null);
      };

      document.addEventListener('scroll', handleScroll);
      return () => {
        document.removeEventListener('scroll', handleScroll);
      };
    }, []); // updates the coordinates of the tooltip

    React.useEffect(() => {
      let element = rootRef.current;
      if (!element) return;

      (async () => {
        while (debouncedMouseOver && !!tooltipContainer && !!element) {
          element = rootRef.current;
          if (!element) continue;
          const {
            top,
            left,
            width,
            height
          } = element.getBoundingClientRect();
          setTop(top);
          setLeft(left);
          setWidth(width);
          setHeight(height);
          await delay(100);
        }
      })();
    }, [debouncedMouseOver, rootRef, tooltipContainer]); // adds container to the DOM when the user mouses over

    React.useEffect(() => {
      if (!debouncedMouseOver) return;
      const tooltipContainer = document.createElement('div');
      tooltipContainer.classList.add(styles.tooltipContainer);
      document.body.appendChild(tooltipContainer);
      setTooltipContainer(tooltipContainer);
      return () => {
        document.body.removeChild(tooltipContainer);
        setTooltipContainer(null);
      };
    }, [debouncedMouseOver, styles]);

    const handleEnterRoot = () => {
      setIsMouseOverRoot(true);
    };

    const handleLeaveRoot = () => {
      setIsMouseOverRoot(false);
    };

    const handleTooltipEnter = () => {
      setIsMouseOverTooltip(true);
    };

    const handleTooltipLeave = () => {
      setIsMouseOverTooltip(false);
    };

    return /*#__PURE__*/React__default.createElement(React__default.Fragment, null, children({
      ref: rootRef,
      onMouseEnter: handleEnterRoot,
      onMouseLeave: handleLeaveRoot
    }), tooltipContainer && reactDom.createPortal( /*#__PURE__*/React__default.createElement(Root, {
      className: classNames({
        [styles.top]: position === 'top',
        [styles.bottom]: position === 'bottom',
        [styles.left]: position === 'left',
        [styles.right]: position === 'right'
      }),
      onMouseEnter: handleTooltipEnter,
      onMouseLeave: handleTooltipLeave,
      style: {
        top: tooltipTop,
        left: tooltipLeft
      }
    }, title), tooltipContainer));
  }

  function _templateObject2$c() {
    const data = _taggedTemplateLiteral(["\n    overflow: auto;\n  "]);

    _templateObject2$c = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$j() {
    const data = _taggedTemplateLiteral(["\n    border-radius: ", ";\n    margin: ", " ", ";\n    box-shadow: 0px 2px 6px 0px ", ";\n  "]);

    _templateObject$j = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$i = reactStyleSystem.createStyles(({
    css,
    theme
  }) => ({
    // table container base styles
    root: css(_templateObject$j(), theme.borderRadius, theme.space(1), theme.space(0.5), theme.bland),
    responsive: css(_templateObject2$c())
  }));
  const TableContainer = React.forwardRef((props, ref) => {
    const _useStyles = useStyles$i(props, 'div'),
          {
      Root,
      styles,
      responsive = true
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "responsive"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      className: classNames({
        [styles.responsive]: responsive
      }),
      ref: ref
    }, restOfProps));
  });
  TableContainer.displayName = 'TableContainer';

  function _templateObject5$a() {
    const data = _taggedTemplateLiteral(["\n    tr > :first-child {\n      position: sticky;\n      left: 0;\n      z-index: 1;\n    }\n  "]);

    _templateObject5$a = function _templateObject5() {
      return data;
    };

    return data;
  }

  function _templateObject4$c() {
    const data = _taggedTemplateLiteral(["\n    th,\n    td {\n      border: none;\n    }\n  "]);

    _templateObject4$c = function _templateObject4() {
      return data;
    };

    return data;
  }

  function _templateObject3$c() {
    const data = _taggedTemplateLiteral(["\n    tbody tr:nth-child(odd) {\n      th,\n      td {\n        background-color: ", ";\n      }\n    }\n    th,\n    td {\n      border: none;\n    }\n  "]);

    _templateObject3$c = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2$d() {
    const data = _taggedTemplateLiteral(["\n    th,\n    td {\n      border: 1px solid ", ";\n    }\n  "]);

    _templateObject2$d = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$k() {
    const data = _taggedTemplateLiteral(["\n    ", "\n    color: ", ";\n    border-spacing: ", ";\n    width: 100%;\n    min-width: 500px;\n    border-collapse: collapse;\n    text-align: left;\n    \n    th, td {\n      background-color: ", ";\n      border-bottom: 1px solid ", ";\n      padding: ", "\n    }\n  "]);

    _templateObject$k = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$j = reactStyleSystem.createStyles(({
    css,
    theme,
    surface
  }) => ({
    // table base styles
    root: css(_templateObject$k(), theme.body2, reactStyleSystem.readableColor(surface), theme.space(0.5), surface, theme.bland, theme.space(1)),
    // variants
    contained: css(_templateObject2$d(), theme.bland),
    striped: css(_templateObject3$c(), reactStyleSystem.mix(theme.bland, surface, 0.85)),
    ghost: css(_templateObject4$c()),
    // Other props
    stickyFirstColumn: css(_templateObject5$a())
  }));
  const Table = React.forwardRef((props, ref) => {
    const _useStyles = useStyles$j(props, 'table'),
          {
      Root,
      styles,
      variant = 'outlined',
      stickyFirstColumn = true
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "variant", "stickyFirstColumn"]);

    const {
      color,
      surface
    } = reactStyleSystem.useColorContext(props);
    return /*#__PURE__*/React__default.createElement(reactStyleSystem.ColorContextProvider, {
      color: color.original,
      surface: surface
    }, /*#__PURE__*/React__default.createElement(Root, _extends({
      className: classNames({
        [styles.contained]: variant === 'contained',
        [styles.striped]: variant === 'striped',
        [styles.ghost]: variant === 'ghost',
        [styles.stickyFirstColumn]: stickyFirstColumn
      }),
      ref: ref
    }, restOfProps)));
  });
  Table.displayName = 'Table';

  function _templateObject$l() {
    const data = _taggedTemplateLiteral(["\n    ", "\n    display: table-caption;\n    text-align: center;\n    margin: ", ";\n    caption-side: bottom;\n  "]);

    _templateObject$l = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$k = reactStyleSystem.createStyles(({
    css,
    theme
  }) => ({
    // table caption base styles
    root: css(_templateObject$l(), theme.caption, theme.space(1))
  }));
  const TableCaption = React.forwardRef((props, ref) => {
    const _useStyles = useStyles$k(props, 'caption'),
          {
      Root,
      styles
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref
    }, restOfProps));
  });
  TableCaption.displayName = 'TableCaption';

  function _templateObject$m() {
    const data = _taggedTemplateLiteral(["\n    th {\n      font-weight: 600;\n    }\n  "]);

    _templateObject$m = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$l = reactStyleSystem.createStyles(({
    css
  }) => ({
    // table head base styles
    root: css(_templateObject$m())
  }));
  const TableHead = React.forwardRef((props, ref) => {
    const _useStyles = useStyles$l(props, 'thead'),
          {
      Root,
      styles
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref
    }, restOfProps));
  });
  TableHead.displayName = 'TableHead';

  const TableBody = 'tbody';

  function _templateObject2$e() {
    const data = _taggedTemplateLiteral(["\n    :hover {\n      th,\n      td {\n        background-color: ", " !important;\n        transition: background-color 0.2s;\n      }\n    }\n  "]);

    _templateObject2$e = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$n() {
    const data = _taggedTemplateLiteral(["\n    > :first-child {\n      min-width: 240px;\n    }\n  "]);

    _templateObject$n = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$m = reactStyleSystem.createStyles(({
    css,
    color,
    surface
  }) => ({
    // table row base styles
    root: css(_templateObject$n()),
    hoverable: css(_templateObject2$e(), reactStyleSystem.mix(color.decorative, surface, 0.75))
  }));
  const TableRow = React.forwardRef((props, ref) => {
    const _useStyles = useStyles$m(props, 'tr'),
          {
      Root,
      styles,
      hoverable = false
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "hoverable"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      className: classNames({
        [styles.hoverable]: hoverable
      }),
      ref: ref
    }, restOfProps));
  });
  TableRow.displayName = 'TableRow';

  function _templateObject$o() {
    const data = _taggedTemplateLiteral(["\n    font-weight: normal;\n    min-width: 120px;\n  "]);

    _templateObject$o = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$n = reactStyleSystem.createStyles(({
    css
  }) => ({
    // table header cell base styles
    root: css(_templateObject$o())
  }));
  const TableHeaderCell = React.forwardRef((props, ref) => {
    const _useStyles = useStyles$n(props, 'th'),
          {
      Root,
      styles
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref
    }, restOfProps));
  });
  TableHeaderCell.displayName = 'TableHeaderCell';

  const TableBodyCell = 'td';

  function _templateObject3$d() {
    const data = _taggedTemplateLiteral(["\n    position: fixed;\n    top: 0;\n    left: 0;\n    bottom: 0;\n    right: 0;\n    background-color: ", ";\n    z-index: ", ";\n  "]);

    _templateObject3$d = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2$f() {
    const data = _taggedTemplateLiteral(["\n    position: fixed;\n    top: 0;\n    left: 0;\n    bottom: 0;\n    right: 0;\n    display: flex;\n  "]);

    _templateObject2$f = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$p() {
    const data = _taggedTemplateLiteral(["\n    max-height: 90%;\n    width: ", ";\n    max-width: 100%;\n    background-color: ", ";\n    color: ", ";\n    z-index: ", ";\n    margin: auto;\n    overflow: hidden;\n    display: flex;\n    flex-direction: column;\n    z-index: ", ";\n  "]);

    _templateObject$p = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$o = reactStyleSystem.createStyles(({
    css,
    theme,
    staticVar
  }) => ({
    root: css(_templateObject$p(), theme.block(8), theme.surface, reactStyleSystem.readableColor(theme.surface), theme.zIndex.modal, theme.zIndex.modal),
    container: css(_templateObject2$f()),
    backdrop: css(_templateObject3$d(), staticVar(reactStyleSystem.transparentize('black', 0.5)), theme.zIndex.modal)
  }));
  const Modal = React.forwardRef((props, ref) => {
    var _props$component;

    const _useStyles = useStyles$o(props, (_props$component = props.component) !== null && _props$component !== void 0 ? _props$component : 'section'),
          {
      Root,
      styles,
      open,
      component: _component,
      // TODO: in the future, we should bind to the escape button for closing
      onClose
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "open", "component", "onClose"]);

    const [container, setContainer] = React.useState(null); // TODO: animations would be a nice-to-have

    React.useEffect(() => {
      if (!open) return;
      const container = document.createElement('div');
      container.classList.add(styles.container);
      document.body.appendChild(container);
      setContainer(container);
      return () => {
        document.body.removeChild(container);
        setContainer(null);
      };
    }, [open, props.style, styles.container]);
    React.useEffect(() => {
      if (!container) return;

      for (const [k, v] of Object.entries(styles.cssVariableObject)) {
        container.style.setProperty(k, v);
      }
    }, [container, styles.cssVariableObject]); // TODO: throw something in the DOM later for SSR SEO

    return container && reactDom.createPortal( /*#__PURE__*/React__default.createElement(React__default.Fragment, null, /*#__PURE__*/React__default.createElement("div", {
      className: styles.backdrop,
      onClick: onClose
    }), /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref
    }, restOfProps))), container);
  });
  Modal.displayName = 'Modal';

  function _templateObject$q() {
    const data = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: column;\n    overflow: hidden;\n    flex: 0 0 auto;\n    padding: ", " 0;\n  "]);

    _templateObject$q = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$p = reactStyleSystem.createStyles(({
    css,
    theme
  }) => ({
    root: css(_templateObject$q(), theme.space(1))
  }));
  const ModalHeader = React.forwardRef((props, ref) => {
    var _props$component;

    const _useStyles = useStyles$p(props, (_props$component = props.component) !== null && _props$component !== void 0 ? _props$component : 'header'),
          {
      Root,
      styles,
      component
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "component"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref
    }, restOfProps));
  });
  ModalHeader.displayName = 'ModalHeader';

  function _templateObject$r() {
    const data = _taggedTemplateLiteral(["\n    flex: 1 1 auto;\n    position: relative;\n    min-height: 50vh;\n    overflow: hidden;\n    display: flex;\n    flex-direction: column;\n  "]);

    _templateObject$r = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$q = reactStyleSystem.createStyles(({
    css
  }) => ({
    root: css(_templateObject$r())
  }));
  const ModalContent = React.forwardRef((props, ref) => {
    var _props$component;

    const _useStyles = useStyles$q(props, (_props$component = props.component) !== null && _props$component !== void 0 ? _props$component : 'div'),
          {
      Root,
      styles,
      component
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "component"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref
    }, restOfProps));
  });
  ModalContent.displayName = 'ModalContent';

  function _templateObject$s() {
    const data = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: column;\n    overflow: hidden;\n    flex: 0 0 auto;\n    padding-bottom: ", ";\n  "]);

    _templateObject$s = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$r = reactStyleSystem.createStyles(({
    css,
    theme
  }) => ({
    root: css(_templateObject$s(), theme.space(1))
  }));
  const ModalFooter = React.forwardRef((props, ref) => {
    var _props$component;

    const _useStyles = useStyles$r(props, (_props$component = props.component) !== null && _props$component !== void 0 ? _props$component : 'footer'),
          {
      Root,
      styles,
      component
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "component"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref
    }, restOfProps));
  });
  ModalFooter.displayName = 'ModalFooter';

  function _templateObject$t() {
    const data = _taggedTemplateLiteral(["\n    display: flex;\n    justify-content: flex-end;\n    padding: 0 ", ";\n    margin-top: ", ";\n    & > *:not(:first-child) {\n      margin-left: ", ";\n    }\n  "]);

    _templateObject$t = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$s = reactStyleSystem.createStyles(({
    css,
    theme
  }) => ({
    root: css(_templateObject$t(), theme.space(1), theme.space(1), theme.space(1))
  }));
  const ModalActions = React.forwardRef((props, ref) => {
    var _props$component;

    const _useStyles = useStyles$s(props, (_props$component = props.component) !== null && _props$component !== void 0 ? _props$component : 'div'),
          {
      Root,
      styles,
      component
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "component"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref
    }, restOfProps));
  });
  ModalActions.displayName = 'ModalActions';

  function _templateObject2$g() {
    const data = _taggedTemplateLiteral(["\n    font-size: 1.7em;\n    position: absolute;\n    top: 50%;\n    transform: translateY(-50%);\n  "]);

    _templateObject2$g = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$u() {
    const data = _taggedTemplateLiteral(["\n    height: 1em;\n    line-height: 1;\n    width: 1.7em;\n    display: inline-flex;\n    position: relative;\n    overflow: visible;\n  "]);

    _templateObject$u = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$t = reactStyleSystem.createStyles(({
    css,
    theme
  }) => ({
    root: css(_templateObject$u()),
    wrapper: css(_templateObject2$g())
  }));
  const Emoji = React.forwardRef((props, ref) => {
    const _useStyles = useStyles$t(props, 'span'),
          {
      Root,
      styles,
      children
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "children"]);

    return /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref
    }, restOfProps), /*#__PURE__*/React__default.createElement("span", {
      className: styles.wrapper
    }, children));
  });
  Emoji.displayName = 'Emoji';

  function _templateObject7$6() {
    const data = _taggedTemplateLiteral(["\n    position: fixed;\n    top: 0;\n    left: 0;\n    bottom: 0;\n    right: 0;\n    z-index: ", ";\n  "]);

    _templateObject7$6 = function _templateObject7() {
      return data;
    };

    return data;
  }

  function _templateObject6$7() {
    const data = _taggedTemplateLiteral(["\n    position: fixed;\n    width: 100vw;\n    height: 100vh;\n    top: 0;\n    left: 0;\n    display: flex;\n  "]);

    _templateObject6$7 = function _templateObject6() {
      return data;
    };

    return data;
  }

  function _templateObject5$b() {
    const data = _taggedTemplateLiteral(["\n    transform: translate(0, -50%);\n  "]);

    _templateObject5$b = function _templateObject5() {
      return data;
    };

    return data;
  }

  function _templateObject4$d() {
    const data = _taggedTemplateLiteral(["\n    transform: translate(-50%, 0);\n  "]);

    _templateObject4$d = function _templateObject4() {
      return data;
    };

    return data;
  }

  function _templateObject3$e() {
    const data = _taggedTemplateLiteral(["\n    transform: translate(-100%, -50%);\n  "]);

    _templateObject3$e = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2$h() {
    const data = _taggedTemplateLiteral(["\n    transform: translate(-50%, -100%);\n  "]);

    _templateObject2$h = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$v() {
    const data = _taggedTemplateLiteral(["\n    position: absolute;\n    width: ", ";\n    box-shadow: ", ";\n    background-color: ", ";\n    z-index: ", ";\n  "]);

    _templateObject$v = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$u = reactStyleSystem.createStyles(({
    css,
    theme
  }) => ({
    root: css(_templateObject$v(), theme.block(2), theme.shadows.subtle, theme.surface, theme.zIndex.modal),
    top: css(_templateObject2$h()),
    left: css(_templateObject3$e()),
    bottom: css(_templateObject4$d()),
    right: css(_templateObject5$b()),
    container: css(_templateObject6$7()),
    backdrop: css(_templateObject7$6(), theme.zIndex.modal)
  }));
  const Menu = React.forwardRef((props, ref) => {
    const _useStyles = useStyles$u(props, props.component ? props.component : 'div'),
          {
      Root,
      styles,
      anchorEl,
      onClose,
      component,
      position = 'bottom',
      children
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "anchorEl", "onClose", "component", "position", "children"]);

    const [container, setContainer] = React.useState(null);
    const [boundingBox, setBoundingBox] = React.useState({
      top: 0,
      left: 0,
      width: 0,
      height: 0
    });
    let top;
    let left;
    const topCenter = boundingBox.top + boundingBox.height / 2;
    const leftCenter = boundingBox.left + boundingBox.width / 2; // TODO: possibly add other positions:
    // ellipsis menus with icons buttons look bad

    if (position === 'left') {
      top = topCenter;
      left = boundingBox.left;
    } else if (position === 'right') {
      top = topCenter;
      left = boundingBox.left + boundingBox.width;
    } else if (position === 'bottom') {
      top = boundingBox.top + boundingBox.height;
      left = leftCenter;
    } else {
      top = boundingBox.top;
      left = leftCenter;
    } // TODO: animations would be nice


    React.useEffect(() => {
      if (!anchorEl) return;
      const container = document.createElement('div');
      container.classList.add(styles.container);
      document.body.appendChild(container);
      setContainer(container);
      const {
        top,
        left,
        width,
        height
      } = anchorEl.getBoundingClientRect();
      setBoundingBox({
        top,
        left,
        width,
        height
      });
      return () => {
        document.body.removeChild(container);
        setContainer(null);
      };
    }, [anchorEl, styles.container]);
    return container && reactDom.createPortal( /*#__PURE__*/React__default.createElement(React__default.Fragment, null, /*#__PURE__*/React__default.createElement("div", {
      className: styles.backdrop,
      onClick: onClose
    }), /*#__PURE__*/React__default.createElement(Root, _extends({
      className: classNames({
        [styles.top]: position === 'top',
        [styles.bottom]: position === 'bottom',
        [styles.left]: position === 'left',
        [styles.right]: position === 'right'
      }),
      ref: ref,
      style: {
        top,
        left
      }
    }, restOfProps), children)), container);
  });
  Menu.displayName = 'Menu';

  function useMediaQuery(query) {
    const normalizedQuery = query.startsWith('@media') ? query.substring('@media'.length, query.length) : query;
    const mediaQueryList = React.useMemo(() => matchMedia(normalizedQuery), [normalizedQuery]);
    const [matches, setMatches] = React.useState(mediaQueryList.matches);
    React.useEffect(() => {
      const handleChange = e => {
        setMatches(e.matches);
      };

      mediaQueryList.addListener(handleChange);
      return () => {
        mediaQueryList.removeListener(handleChange);
      };
    }, [mediaQueryList]);
    return matches;
  }

  function _templateObject3$f() {
    const data = _taggedTemplateLiteral(["\n    position: fixed;\n    top: 0;\n    left: 0;\n    bottom: 0;\n    right: 0;\n    background-color: ", ";\n    z-index: ", ";\n  "]);

    _templateObject3$f = function _templateObject3() {
      return data;
    };

    return data;
  }

  function _templateObject2$i() {
    const data = _taggedTemplateLiteral(["\n    position: fixed;\n    top: 0;\n    left: 0;\n    bottom: 0;\n    right: 0;\n    display: flex;\n  "]);

    _templateObject2$i = function _templateObject2() {
      return data;
    };

    return data;
  }

  function _templateObject$w() {
    const data = _taggedTemplateLiteral(["\n    background-color: ", ";\n    box-shadow: ", ";\n    width: ", ";\n    max-width: 100%;\n    height: 100%;\n    z-index: ", ";\n  "]);

    _templateObject$w = function _templateObject() {
      return data;
    };

    return data;
  }
  const useStyles$v = reactStyleSystem.createStyles(({
    css,
    theme
  }) => ({
    root: css(_templateObject$w(), theme.surface, theme.shadows.standard, theme.block(3), theme.zIndex.drawer),
    container: css(_templateObject2$i()),
    backdrop: css(_templateObject3$f(), reactStyleSystem.transparentize('black', 0.5), theme.zIndex.drawer)
  }));
  const Drawer = React.forwardRef((props, ref) => {
    var _props$component;

    const _useStyles = useStyles$v(props, (_props$component = props.component) !== null && _props$component !== void 0 ? _props$component : 'div'),
          {
      Root,
      styles,
      component: _component,
      open,
      onClose
    } = _useStyles,
          restOfProps = _objectWithoutProperties(_useStyles, ["Root", "styles", "component", "open", "onClose"]);

    const [container, setContainer] = React.useState(null); // TODO: animations would be a nice-to-have

    React.useEffect(() => {
      if (!open) return;
      const container = document.createElement('div');
      container.classList.add(styles.container);
      document.body.appendChild(container);
      setContainer(container);
      return () => {
        document.body.removeChild(container);
        setContainer(null);
      };
    }, [open, styles.container]);
    React.useEffect(() => {
      if (!container) return;

      for (const [k, v] of Object.entries(styles.cssVariableObject)) {
        container.style.setProperty(k, v);
      }
    }, [container, styles.cssVariableObject]); // TODO: SSR/SEO audit

    return container && reactDom.createPortal( /*#__PURE__*/React__default.createElement(React__default.Fragment, null, /*#__PURE__*/React__default.createElement("div", {
      className: styles.backdrop,
      onClick: onClose
    }), /*#__PURE__*/React__default.createElement(Root, _extends({
      ref: ref
    }, restOfProps))), container);
  });
  Drawer.displayName = 'Drawer';

  exports.Anchor = Anchor;
  exports.Button = Button;
  exports.CheckIcon = CheckIcon;
  exports.Checkbox = Checkbox;
  exports.Chip = Chip;
  exports.ChipThumbnail = ChipThumbnail;
  exports.CircleIcon = CircleIcon;
  exports.Drawer = Drawer;
  exports.Emoji = Emoji;
  exports.FormControl = FormControl;
  exports.HelperText = HelperText;
  exports.Label = Label;
  exports.List = List;
  exports.ListItem = ListItem;
  exports.ListItemButton = ListItemButton;
  exports.Menu = Menu;
  exports.Modal = Modal;
  exports.ModalActions = ModalActions;
  exports.ModalContent = ModalContent;
  exports.ModalFooter = ModalFooter;
  exports.ModalHeader = ModalHeader;
  exports.Radio = Radio;
  exports.RadioGroup = RadioGroup;
  exports.Select = Select;
  exports.Switch = Switch;
  exports.Table = Table;
  exports.TableBody = TableBody;
  exports.TableBodyCell = TableBodyCell;
  exports.TableCaption = TableCaption;
  exports.TableContainer = TableContainer;
  exports.TableHead = TableHead;
  exports.TableHeaderCell = TableHeaderCell;
  exports.TableRow = TableRow;
  exports.TextArea = TextArea;
  exports.TextInput = TextInput;
  exports.ThemeProvider = ThemeProvider;
  exports.TimesIcon = TimesIcon;
  exports.Tooltip = Tooltip;
  exports.createTheme = createTheme;
  exports.defaultTheme = defaultTheme;
  exports.useMediaQuery = useMediaQuery;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=bundle.umd.js.map
